
module Make

# 4 "src/languages/smtlib2/v2.6/script/parser.mly"
           (L : Dolmen_intf.Location.S)
# 7 "src/languages/smtlib2/v2.6/script/parser.ml"


# 5 "src/languages/smtlib2/v2.6/script/parser.mly"
           (I : Ast.Id)
# 12 "src/languages/smtlib2/v2.6/script/parser.ml"


# 6 "src/languages/smtlib2/v2.6/script/parser.mly"
           (T : Ast.Term with type location := L.t and type id := I.t)
# 17 "src/languages/smtlib2/v2.6/script/parser.ml"


# 7 "src/languages/smtlib2/v2.6/script/parser.mly"
           (S : Ast.Statement with type location := L.t and type id := I.t and type term := T.t)
# 22 "src/languages/smtlib2/v2.6/script/parser.ml"

= struct
  
  module MenhirBasics = struct
    
    exception Error of int
    
    let _eRR =
      fun _s ->
        raise (Error _s)
    
    type token = Tokens.token
    
  end
  
  include MenhirBasics
  
# 13 "src/languages/smtlib2/v2.6/script/parser.mly"
  

  let pp_num_list fmt (l, singular, plural) =
    let n = List.length l in
    Format.fprintf fmt "%d %s" n (if n = 1 then singular else plural)

  let mismatched_lists ~loc l1 l2 =
    let msg = Format.dprintf
      "@[<v>@[<hov>Expected@ two@ lists@ of@ the@ same@ size,@ but@ got:@]@ \
        - @[<hov>%a@]@ - @[<hov>%a@]@]"
      pp_num_list l1 pp_num_list l2
    in
    raise (L.Syntax_error (loc, `Regular msg))


# 56 "src/languages/smtlib2/v2.6/script/parser.ml"
  
  type ('s, 'r) _menhir_state = 
    | MenhirState000 : ('s, _menhir_box_file) _menhir_state
      (** State 000.
        Stack shape : .
        Start symbol: file. *)

    | MenhirState002 : (('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_SET_OPTION, _menhir_box_file) _menhir_state
      (** State 002.
        Stack shape : OPEN SET_OPTION.
        Start symbol: file. *)

    | MenhirState003 : (('s, 'r) _menhir_cell1_KEYWORD, 'r) _menhir_state
      (** State 003.
        Stack shape : KEYWORD.
        Start symbol: <undetermined>. *)

    | MenhirState006 : ((('s, 'r) _menhir_cell1_KEYWORD, 'r) _menhir_cell1_OPEN, 'r) _menhir_state
      (** State 006.
        Stack shape : KEYWORD OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState017 : (('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_state
      (** State 017.
        Stack shape : OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState053 : (('s, 'r) _menhir_cell1_s_expr, 'r) _menhir_state
      (** State 053.
        Stack shape : s_expr.
        Start symbol: <undetermined>. *)

    | MenhirState069 : (('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_SET_INFO, _menhir_box_file) _menhir_state
      (** State 069.
        Stack shape : OPEN SET_INFO.
        Start symbol: file. *)

    | MenhirState083 : (('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_GET_VALUE _menhir_cell0_OPEN, _menhir_box_file) _menhir_state
      (** State 083.
        Stack shape : OPEN GET_VALUE OPEN.
        Start symbol: file. *)

    | MenhirState085 : (('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_state
      (** State 085.
        Stack shape : OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState087 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_UNDERSCORE _menhir_cell0_SYMBOL, 'r) _menhir_state
      (** State 087.
        Stack shape : OPEN UNDERSCORE SYMBOL.
        Start symbol: <undetermined>. *)

    | MenhirState093 : (('s, 'r) _menhir_cell1_index, 'r) _menhir_state
      (** State 093.
        Stack shape : index.
        Start symbol: <undetermined>. *)

    | MenhirState095 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_OPEN, 'r) _menhir_state
      (** State 095.
        Stack shape : OPEN OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState096 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_AS, 'r) _menhir_state
      (** State 096.
        Stack shape : OPEN AS.
        Start symbol: <undetermined>. *)

    | MenhirState097 : (('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_state
      (** State 097.
        Stack shape : OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState098 : (((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_AS, 'r) _menhir_cell1_identifier, 'r) _menhir_state
      (** State 098.
        Stack shape : OPEN AS identifier.
        Start symbol: <undetermined>. *)

    | MenhirState099 : (('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_state
      (** State 099.
        Stack shape : OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState100 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_identifier, 'r) _menhir_state
      (** State 100.
        Stack shape : OPEN identifier.
        Start symbol: <undetermined>. *)

    | MenhirState101 : (('s, 'r) _menhir_cell1_sort, 'r) _menhir_state
      (** State 101.
        Stack shape : sort.
        Start symbol: <undetermined>. *)

    | MenhirState108 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_MATCH, 'r) _menhir_state
      (** State 108.
        Stack shape : OPEN MATCH.
        Start symbol: <undetermined>. *)

    | MenhirState110 : (((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_MATCH, 'r) _menhir_cell1_term _menhir_cell0_OPEN, 'r) _menhir_state
      (** State 110.
        Stack shape : OPEN MATCH term OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState111 : (('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_state
      (** State 111.
        Stack shape : OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState113 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_OPEN, 'r) _menhir_state
      (** State 113.
        Stack shape : OPEN OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState114 : (((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_pattern_symbol, 'r) _menhir_state
      (** State 114.
        Stack shape : OPEN OPEN pattern_symbol.
        Start symbol: <undetermined>. *)

    | MenhirState115 : ((('s, 'r) _menhir_cell1_pattern_symbol, 'r) _menhir_cell1_pattern_symbol, 'r) _menhir_state
      (** State 115.
        Stack shape : pattern_symbol pattern_symbol.
        Start symbol: <undetermined>. *)

    | MenhirState120 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_pattern, 'r) _menhir_state
      (** State 120.
        Stack shape : OPEN pattern.
        Start symbol: <undetermined>. *)

    | MenhirState129 : (('s, 'r) _menhir_cell1_match_case, 'r) _menhir_state
      (** State 129.
        Stack shape : match_case.
        Start symbol: <undetermined>. *)

    | MenhirState132 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_LET _menhir_cell0_OPEN, 'r) _menhir_state
      (** State 132.
        Stack shape : OPEN LET OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState134 : (('s, 'r) _menhir_cell1_OPEN _menhir_cell0_SYMBOL, 'r) _menhir_state
      (** State 134.
        Stack shape : OPEN SYMBOL.
        Start symbol: <undetermined>. *)

    | MenhirState137 : (('s, 'r) _menhir_cell1_var_binding, 'r) _menhir_state
      (** State 137.
        Stack shape : var_binding.
        Start symbol: <undetermined>. *)

    | MenhirState140 : (((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_LET _menhir_cell0_OPEN, 'r) _menhir_cell1_nonempty_list_var_binding_ _menhir_cell0_CLOSE, 'r) _menhir_state
      (** State 140.
        Stack shape : OPEN LET OPEN nonempty_list(var_binding) CLOSE.
        Start symbol: <undetermined>. *)

    | MenhirState144 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_FORALL _menhir_cell0_OPEN, 'r) _menhir_state
      (** State 144.
        Stack shape : OPEN FORALL OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState146 : (('s, 'r) _menhir_cell1_OPEN _menhir_cell0_SYMBOL, 'r) _menhir_state
      (** State 146.
        Stack shape : OPEN SYMBOL.
        Start symbol: <undetermined>. *)

    | MenhirState149 : (('s, 'r) _menhir_cell1_sorted_var, 'r) _menhir_state
      (** State 149.
        Stack shape : sorted_var.
        Start symbol: <undetermined>. *)

    | MenhirState152 : (((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_FORALL _menhir_cell0_OPEN, 'r) _menhir_cell1_nonempty_list_sorted_var_ _menhir_cell0_CLOSE, 'r) _menhir_state
      (** State 152.
        Stack shape : OPEN FORALL OPEN nonempty_list(sorted_var) CLOSE.
        Start symbol: <undetermined>. *)

    | MenhirState156 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_EXISTS _menhir_cell0_OPEN, 'r) _menhir_state
      (** State 156.
        Stack shape : OPEN EXISTS OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState158 : (((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_EXISTS _menhir_cell0_OPEN, 'r) _menhir_cell1_nonempty_list_sorted_var_ _menhir_cell0_CLOSE, 'r) _menhir_state
      (** State 158.
        Stack shape : OPEN EXISTS OPEN nonempty_list(sorted_var) CLOSE.
        Start symbol: <undetermined>. *)

    | MenhirState161 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_ATTRIBUTE, 'r) _menhir_state
      (** State 161.
        Stack shape : OPEN ATTRIBUTE.
        Start symbol: <undetermined>. *)

    | MenhirState162 : (((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_ATTRIBUTE, 'r) _menhir_cell1_term, 'r) _menhir_state
      (** State 162.
        Stack shape : OPEN ATTRIBUTE term.
        Start symbol: <undetermined>. *)

    | MenhirState165 : (('s, 'r) _menhir_cell1_attribute, 'r) _menhir_state
      (** State 165.
        Stack shape : attribute.
        Start symbol: <undetermined>. *)

    | MenhirState167 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_qual_identifier, 'r) _menhir_state
      (** State 167.
        Stack shape : OPEN qual_identifier.
        Start symbol: <undetermined>. *)

    | MenhirState168 : (('s, 'r) _menhir_cell1_term, 'r) _menhir_state
      (** State 168.
        Stack shape : term.
        Start symbol: <undetermined>. *)

    | MenhirState186 : (('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_GET_INFO, _menhir_box_file) _menhir_state
      (** State 186.
        Stack shape : OPEN GET_INFO.
        Start symbol: file. *)

    | MenhirState201 : (('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DEFINE_SORT _menhir_cell0_SYMBOL _menhir_cell0_OPEN, _menhir_box_file) _menhir_state
      (** State 201.
        Stack shape : OPEN DEFINE_SORT SYMBOL OPEN.
        Start symbol: file. *)

    | MenhirState202 : (('s, 'r) _menhir_cell1_SYMBOL, 'r) _menhir_state
      (** State 202.
        Stack shape : SYMBOL.
        Start symbol: <undetermined>. *)

    | MenhirState205 : ((('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DEFINE_SORT _menhir_cell0_SYMBOL _menhir_cell0_OPEN, _menhir_box_file) _menhir_cell1_list_SYMBOL_ _menhir_cell0_CLOSE, _menhir_box_file) _menhir_state
      (** State 205.
        Stack shape : OPEN DEFINE_SORT SYMBOL OPEN list(SYMBOL) CLOSE.
        Start symbol: file. *)

    | MenhirState208 : (('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUN_REC, _menhir_box_file) _menhir_state
      (** State 208.
        Stack shape : OPEN DEFINE_FUN_REC.
        Start symbol: file. *)

    | MenhirState210 : (('s, 'r) _menhir_cell1_SYMBOL _menhir_cell0_OPEN, 'r) _menhir_state
      (** State 210.
        Stack shape : SYMBOL OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState211 : (('s, 'r) _menhir_cell1_sorted_var, 'r) _menhir_state
      (** State 211.
        Stack shape : sorted_var.
        Start symbol: <undetermined>. *)

    | MenhirState214 : ((('s, 'r) _menhir_cell1_SYMBOL _menhir_cell0_OPEN, 'r) _menhir_cell1_list_sorted_var_ _menhir_cell0_CLOSE, 'r) _menhir_state
      (** State 214.
        Stack shape : SYMBOL OPEN list(sorted_var) CLOSE.
        Start symbol: <undetermined>. *)

    | MenhirState215 : (((('s, 'r) _menhir_cell1_SYMBOL _menhir_cell0_OPEN, 'r) _menhir_cell1_list_sorted_var_ _menhir_cell0_CLOSE, 'r) _menhir_cell1_sort, 'r) _menhir_state
      (** State 215.
        Stack shape : SYMBOL OPEN list(sorted_var) CLOSE sort.
        Start symbol: <undetermined>. *)

    | MenhirState220 : (('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUNS_REC _menhir_cell0_OPEN, _menhir_box_file) _menhir_state
      (** State 220.
        Stack shape : OPEN DEFINE_FUNS_REC OPEN.
        Start symbol: file. *)

    | MenhirState223 : (('s, 'r) _menhir_cell1_OPEN _menhir_cell0_SYMBOL _menhir_cell0_OPEN, 'r) _menhir_state
      (** State 223.
        Stack shape : OPEN SYMBOL OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState225 : ((('s, 'r) _menhir_cell1_OPEN _menhir_cell0_SYMBOL _menhir_cell0_OPEN, 'r) _menhir_cell1_list_sorted_var_ _menhir_cell0_CLOSE, 'r) _menhir_state
      (** State 225.
        Stack shape : OPEN SYMBOL OPEN list(sorted_var) CLOSE.
        Start symbol: <undetermined>. *)

    | MenhirState230 : ((('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUNS_REC _menhir_cell0_OPEN, _menhir_box_file) _menhir_cell1_nonempty_list_function_dec_ _menhir_cell0_CLOSE _menhir_cell0_OPEN, _menhir_box_file) _menhir_state
      (** State 230.
        Stack shape : OPEN DEFINE_FUNS_REC OPEN nonempty_list(function_dec) CLOSE OPEN.
        Start symbol: file. *)

    | MenhirState234 : (('s, 'r) _menhir_cell1_function_dec, 'r) _menhir_state
      (** State 234.
        Stack shape : function_dec.
        Start symbol: <undetermined>. *)

    | MenhirState236 : (('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUN, _menhir_box_file) _menhir_state
      (** State 236.
        Stack shape : OPEN DEFINE_FUN.
        Start symbol: file. *)

    | MenhirState245 : (('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DECLARE_FUN _menhir_cell0_SYMBOL _menhir_cell0_OPEN, _menhir_box_file) _menhir_state
      (** State 245.
        Stack shape : OPEN DECLARE_FUN SYMBOL OPEN.
        Start symbol: file. *)

    | MenhirState246 : (('s, 'r) _menhir_cell1_sort, 'r) _menhir_state
      (** State 246.
        Stack shape : sort.
        Start symbol: <undetermined>. *)

    | MenhirState249 : ((('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DECLARE_FUN _menhir_cell0_SYMBOL _menhir_cell0_OPEN, _menhir_box_file) _menhir_cell1_list_sort_ _menhir_cell0_CLOSE, _menhir_box_file) _menhir_state
      (** State 249.
        Stack shape : OPEN DECLARE_FUN SYMBOL OPEN list(sort) CLOSE.
        Start symbol: file. *)

    | MenhirState253 : (('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DECLARE_DATATYPES _menhir_cell0_OPEN, _menhir_box_file) _menhir_state
      (** State 253.
        Stack shape : OPEN DECLARE_DATATYPES OPEN.
        Start symbol: file. *)

    | MenhirState258 : (('s, 'r) _menhir_cell1_sort_dec, 'r) _menhir_state
      (** State 258.
        Stack shape : sort_dec.
        Start symbol: <undetermined>. *)

    | MenhirState262 : ((('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DECLARE_DATATYPES _menhir_cell0_OPEN, _menhir_box_file) _menhir_cell1_nonempty_list_sort_dec_ _menhir_cell0_CLOSE _menhir_cell0_OPEN, _menhir_box_file) _menhir_state
      (** State 262.
        Stack shape : OPEN DECLARE_DATATYPES OPEN nonempty_list(sort_dec) CLOSE OPEN.
        Start symbol: file. *)

    | MenhirState263 : (('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_state
      (** State 263.
        Stack shape : OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState265 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_PAR _menhir_cell0_OPEN, 'r) _menhir_state
      (** State 265.
        Stack shape : OPEN PAR OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState269 : (((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_PAR _menhir_cell0_OPEN, 'r) _menhir_cell1_nonempty_list_datatype_symbol_ _menhir_cell0_CLOSE _menhir_cell0_OPEN, 'r) _menhir_state
      (** State 269.
        Stack shape : OPEN PAR OPEN nonempty_list(datatype_symbol) CLOSE OPEN.
        Start symbol: <undetermined>. *)

    | MenhirState271 : (('s, 'r) _menhir_cell1_OPEN _menhir_cell0_SYMBOL, 'r) _menhir_state
      (** State 271.
        Stack shape : OPEN SYMBOL.
        Start symbol: <undetermined>. *)

    | MenhirState273 : (('s, 'r) _menhir_cell1_OPEN _menhir_cell0_SYMBOL, 'r) _menhir_state
      (** State 273.
        Stack shape : OPEN SYMBOL.
        Start symbol: <undetermined>. *)

    | MenhirState276 : (('s, 'r) _menhir_cell1_selector_dec, 'r) _menhir_state
      (** State 276.
        Stack shape : selector_dec.
        Start symbol: <undetermined>. *)

    | MenhirState283 : (('s, 'r) _menhir_cell1_constructor_dec, 'r) _menhir_state
      (** State 283.
        Stack shape : constructor_dec.
        Start symbol: <undetermined>. *)

    | MenhirState285 : (('s, 'r) _menhir_cell1_datatype_symbol, 'r) _menhir_state
      (** State 285.
        Stack shape : datatype_symbol.
        Start symbol: <undetermined>. *)

    | MenhirState292 : (('s, 'r) _menhir_cell1_datatype_dec, 'r) _menhir_state
      (** State 292.
        Stack shape : datatype_dec.
        Start symbol: <undetermined>. *)

    | MenhirState295 : (('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DECLARE_DATATYPE _menhir_cell0_SYMBOL, _menhir_box_file) _menhir_state
      (** State 295.
        Stack shape : OPEN DECLARE_DATATYPE SYMBOL.
        Start symbol: file. *)

    | MenhirState299 : (('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DECLARE_CONST _menhir_cell0_SYMBOL, _menhir_box_file) _menhir_state
      (** State 299.
        Stack shape : OPEN DECLARE_CONST SYMBOL.
        Start symbol: file. *)

    | MenhirState303 : (('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_CHECK_SAT_ASSUMING _menhir_cell0_OPEN, _menhir_box_file) _menhir_state
      (** State 303.
        Stack shape : OPEN CHECK_SAT_ASSUMING OPEN.
        Start symbol: file. *)

    | MenhirState306 : (('s, 'r) _menhir_cell1_OPEN _menhir_cell0_not_symbol, 'r) _menhir_state
      (** State 306.
        Stack shape : OPEN not_symbol.
        Start symbol: <undetermined>. *)

    | MenhirState311 : (('s, 'r) _menhir_cell1_prop_literal, 'r) _menhir_state
      (** State 311.
        Stack shape : prop_literal.
        Start symbol: <undetermined>. *)

    | MenhirState318 : (('s, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_ASSERT, _menhir_box_file) _menhir_state
      (** State 318.
        Stack shape : OPEN ASSERT.
        Start symbol: file. *)

    | MenhirState324 : (('s, _menhir_box_file) _menhir_cell1_command, _menhir_box_file) _menhir_state
      (** State 324.
        Stack shape : command.
        Start symbol: file. *)

    | MenhirState326 : ('s, _menhir_box_input) _menhir_state
      (** State 326.
        Stack shape : .
        Start symbol: input. *)

    | MenhirState328 : (('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_SET_OPTION, _menhir_box_input) _menhir_state
      (** State 328.
        Stack shape : OPEN SET_OPTION.
        Start symbol: input. *)

    | MenhirState334 : (('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_SET_INFO, _menhir_box_input) _menhir_state
      (** State 334.
        Stack shape : OPEN SET_INFO.
        Start symbol: input. *)

    | MenhirState348 : (('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_GET_VALUE _menhir_cell0_OPEN, _menhir_box_input) _menhir_state
      (** State 348.
        Stack shape : OPEN GET_VALUE OPEN.
        Start symbol: input. *)

    | MenhirState363 : (('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_GET_INFO, _menhir_box_input) _menhir_state
      (** State 363.
        Stack shape : OPEN GET_INFO.
        Start symbol: input. *)

    | MenhirState377 : (('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DEFINE_SORT _menhir_cell0_SYMBOL _menhir_cell0_OPEN, _menhir_box_input) _menhir_state
      (** State 377.
        Stack shape : OPEN DEFINE_SORT SYMBOL OPEN.
        Start symbol: input. *)

    | MenhirState379 : ((('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DEFINE_SORT _menhir_cell0_SYMBOL _menhir_cell0_OPEN, _menhir_box_input) _menhir_cell1_list_SYMBOL_ _menhir_cell0_CLOSE, _menhir_box_input) _menhir_state
      (** State 379.
        Stack shape : OPEN DEFINE_SORT SYMBOL OPEN list(SYMBOL) CLOSE.
        Start symbol: input. *)

    | MenhirState382 : (('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUN_REC, _menhir_box_input) _menhir_state
      (** State 382.
        Stack shape : OPEN DEFINE_FUN_REC.
        Start symbol: input. *)

    | MenhirState386 : (('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUNS_REC _menhir_cell0_OPEN, _menhir_box_input) _menhir_state
      (** State 386.
        Stack shape : OPEN DEFINE_FUNS_REC OPEN.
        Start symbol: input. *)

    | MenhirState389 : ((('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUNS_REC _menhir_cell0_OPEN, _menhir_box_input) _menhir_cell1_nonempty_list_function_dec_ _menhir_cell0_CLOSE _menhir_cell0_OPEN, _menhir_box_input) _menhir_state
      (** State 389.
        Stack shape : OPEN DEFINE_FUNS_REC OPEN nonempty_list(function_dec) CLOSE OPEN.
        Start symbol: input. *)

    | MenhirState393 : (('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUN, _menhir_box_input) _menhir_state
      (** State 393.
        Stack shape : OPEN DEFINE_FUN.
        Start symbol: input. *)

    | MenhirState402 : (('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DECLARE_FUN _menhir_cell0_SYMBOL _menhir_cell0_OPEN, _menhir_box_input) _menhir_state
      (** State 402.
        Stack shape : OPEN DECLARE_FUN SYMBOL OPEN.
        Start symbol: input. *)

    | MenhirState404 : ((('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DECLARE_FUN _menhir_cell0_SYMBOL _menhir_cell0_OPEN, _menhir_box_input) _menhir_cell1_list_sort_ _menhir_cell0_CLOSE, _menhir_box_input) _menhir_state
      (** State 404.
        Stack shape : OPEN DECLARE_FUN SYMBOL OPEN list(sort) CLOSE.
        Start symbol: input. *)

    | MenhirState408 : (('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DECLARE_DATATYPES _menhir_cell0_OPEN, _menhir_box_input) _menhir_state
      (** State 408.
        Stack shape : OPEN DECLARE_DATATYPES OPEN.
        Start symbol: input. *)

    | MenhirState411 : ((('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DECLARE_DATATYPES _menhir_cell0_OPEN, _menhir_box_input) _menhir_cell1_nonempty_list_sort_dec_ _menhir_cell0_CLOSE _menhir_cell0_OPEN, _menhir_box_input) _menhir_state
      (** State 411.
        Stack shape : OPEN DECLARE_DATATYPES OPEN nonempty_list(sort_dec) CLOSE OPEN.
        Start symbol: input. *)

    | MenhirState416 : (('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DECLARE_DATATYPE _menhir_cell0_SYMBOL, _menhir_box_input) _menhir_state
      (** State 416.
        Stack shape : OPEN DECLARE_DATATYPE SYMBOL.
        Start symbol: input. *)

    | MenhirState420 : (('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DECLARE_CONST _menhir_cell0_SYMBOL, _menhir_box_input) _menhir_state
      (** State 420.
        Stack shape : OPEN DECLARE_CONST SYMBOL.
        Start symbol: input. *)

    | MenhirState424 : (('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_CHECK_SAT_ASSUMING _menhir_cell0_OPEN, _menhir_box_input) _menhir_state
      (** State 424.
        Stack shape : OPEN CHECK_SAT_ASSUMING OPEN.
        Start symbol: input. *)

    | MenhirState430 : (('s, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_ASSERT, _menhir_box_input) _menhir_state
      (** State 430.
        Stack shape : OPEN ASSERT.
        Start symbol: input. *)

    | MenhirState436 : ('s, _menhir_box_term) _menhir_state
      (** State 436.
        Stack shape : .
        Start symbol: term. *)

    | MenhirState439 : (('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_state
      (** State 439.
        Stack shape : OPEN.
        Start symbol: term. *)

    | MenhirState441 : ((('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_UNDERSCORE _menhir_cell0_SYMBOL, _menhir_box_term) _menhir_state
      (** State 441.
        Stack shape : OPEN UNDERSCORE SYMBOL.
        Start symbol: term. *)

    | MenhirState444 : ((('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_MATCH, _menhir_box_term) _menhir_state
      (** State 444.
        Stack shape : OPEN MATCH.
        Start symbol: term. *)

    | MenhirState446 : (((('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_MATCH, _menhir_box_term) _menhir_cell1_term _menhir_cell0_OPEN, _menhir_box_term) _menhir_state
      (** State 446.
        Stack shape : OPEN MATCH term OPEN.
        Start symbol: term. *)

    | MenhirState451 : ((('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_LET _menhir_cell0_OPEN, _menhir_box_term) _menhir_state
      (** State 451.
        Stack shape : OPEN LET OPEN.
        Start symbol: term. *)

    | MenhirState453 : (((('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_LET _menhir_cell0_OPEN, _menhir_box_term) _menhir_cell1_nonempty_list_var_binding_ _menhir_cell0_CLOSE, _menhir_box_term) _menhir_state
      (** State 453.
        Stack shape : OPEN LET OPEN nonempty_list(var_binding) CLOSE.
        Start symbol: term. *)

    | MenhirState457 : ((('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_FORALL _menhir_cell0_OPEN, _menhir_box_term) _menhir_state
      (** State 457.
        Stack shape : OPEN FORALL OPEN.
        Start symbol: term. *)

    | MenhirState459 : (((('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_FORALL _menhir_cell0_OPEN, _menhir_box_term) _menhir_cell1_nonempty_list_sorted_var_ _menhir_cell0_CLOSE, _menhir_box_term) _menhir_state
      (** State 459.
        Stack shape : OPEN FORALL OPEN nonempty_list(sorted_var) CLOSE.
        Start symbol: term. *)

    | MenhirState463 : ((('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_EXISTS _menhir_cell0_OPEN, _menhir_box_term) _menhir_state
      (** State 463.
        Stack shape : OPEN EXISTS OPEN.
        Start symbol: term. *)

    | MenhirState465 : (((('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_EXISTS _menhir_cell0_OPEN, _menhir_box_term) _menhir_cell1_nonempty_list_sorted_var_ _menhir_cell0_CLOSE, _menhir_box_term) _menhir_state
      (** State 465.
        Stack shape : OPEN EXISTS OPEN nonempty_list(sorted_var) CLOSE.
        Start symbol: term. *)

    | MenhirState468 : ((('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_ATTRIBUTE, _menhir_box_term) _menhir_state
      (** State 468.
        Stack shape : OPEN ATTRIBUTE.
        Start symbol: term. *)

    | MenhirState469 : (((('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_ATTRIBUTE, _menhir_box_term) _menhir_cell1_term, _menhir_box_term) _menhir_state
      (** State 469.
        Stack shape : OPEN ATTRIBUTE term.
        Start symbol: term. *)

    | MenhirState472 : ((('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_AS, _menhir_box_term) _menhir_state
      (** State 472.
        Stack shape : OPEN AS.
        Start symbol: term. *)

    | MenhirState473 : (((('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_AS, _menhir_box_term) _menhir_cell1_identifier, _menhir_box_term) _menhir_state
      (** State 473.
        Stack shape : OPEN AS identifier.
        Start symbol: term. *)

    | MenhirState476 : ((('s, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_qual_identifier, _menhir_box_term) _menhir_state
      (** State 476.
        Stack shape : OPEN qual_identifier.
        Start symbol: term. *)

  
  and ('s, 'r) _menhir_cell1_attribute = 
    | MenhirCell1_attribute of 's * ('s, 'r) _menhir_state * (T.t)
  
  and ('s, 'r) _menhir_cell1_command = 
    | MenhirCell1_command of 's * ('s, 'r) _menhir_state * (S.t)
  
  and ('s, 'r) _menhir_cell1_constructor_dec = 
    | MenhirCell1_constructor_dec of 's * ('s, 'r) _menhir_state * (I.t * T.t list)
  
  and ('s, 'r) _menhir_cell1_datatype_dec = 
    | MenhirCell1_datatype_dec of 's * ('s, 'r) _menhir_state * (T.t list * (I.t * T.t list) list)
  
  and ('s, 'r) _menhir_cell1_datatype_symbol = 
    | MenhirCell1_datatype_symbol of 's * ('s, 'r) _menhir_state * (T.t)
  
  and ('s, 'r) _menhir_cell1_function_dec = 
    | MenhirCell1_function_dec of 's * ('s, 'r) _menhir_state * (I.t * T.t list * T.t list * T.t)
  
  and ('s, 'r) _menhir_cell1_identifier = 
    | MenhirCell1_identifier of 's * ('s, 'r) _menhir_state * (I.namespace -> I.t) * Lexing.position * Lexing.position
  
  and ('s, 'r) _menhir_cell1_index = 
    | MenhirCell1_index of 's * ('s, 'r) _menhir_state * (string)
  
  and ('s, 'r) _menhir_cell1_list_SYMBOL_ = 
    | MenhirCell1_list_SYMBOL_ of 's * ('s, 'r) _menhir_state * (string list)
  
  and ('s, 'r) _menhir_cell1_list_sort_ = 
    | MenhirCell1_list_sort_ of 's * ('s, 'r) _menhir_state * (T.t list)
  
  and ('s, 'r) _menhir_cell1_list_sorted_var_ = 
    | MenhirCell1_list_sorted_var_ of 's * ('s, 'r) _menhir_state * (T.t list)
  
  and ('s, 'r) _menhir_cell1_match_case = 
    | MenhirCell1_match_case of 's * ('s, 'r) _menhir_state * (T.t * T.t)
  
  and ('s, 'r) _menhir_cell1_nonempty_list_datatype_symbol_ = 
    | MenhirCell1_nonempty_list_datatype_symbol_ of 's * ('s, 'r) _menhir_state * (T.t list)
  
  and ('s, 'r) _menhir_cell1_nonempty_list_function_dec_ = 
    | MenhirCell1_nonempty_list_function_dec_ of 's * ('s, 'r) _menhir_state * ((I.t * T.t list * T.t list * T.t) list)
  
  and ('s, 'r) _menhir_cell1_nonempty_list_sort_dec_ = 
    | MenhirCell1_nonempty_list_sort_dec_ of 's * ('s, 'r) _menhir_state * ((I.t * int) list)
  
  and ('s, 'r) _menhir_cell1_nonempty_list_sorted_var_ = 
    | MenhirCell1_nonempty_list_sorted_var_ of 's * ('s, 'r) _menhir_state * (T.t list)
  
  and ('s, 'r) _menhir_cell1_nonempty_list_var_binding_ = 
    | MenhirCell1_nonempty_list_var_binding_ of 's * ('s, 'r) _menhir_state * (T.t list)
  
  and 's _menhir_cell0_not_symbol = 
    | MenhirCell0_not_symbol of 's * (T.t)
  
  and ('s, 'r) _menhir_cell1_pattern = 
    | MenhirCell1_pattern of 's * ('s, 'r) _menhir_state * (T.t)
  
  and ('s, 'r) _menhir_cell1_pattern_symbol = 
    | MenhirCell1_pattern_symbol of 's * ('s, 'r) _menhir_state * (T.t)
  
  and ('s, 'r) _menhir_cell1_prop_literal = 
    | MenhirCell1_prop_literal of 's * ('s, 'r) _menhir_state * (T.t)
  
  and ('s, 'r) _menhir_cell1_qual_identifier = 
    | MenhirCell1_qual_identifier of 's * ('s, 'r) _menhir_state * ([ `As of T.t * T.t * L.t | `NoAs of T.t ])
  
  and ('s, 'r) _menhir_cell1_s_expr = 
    | MenhirCell1_s_expr of 's * ('s, 'r) _menhir_state * (T.t)
  
  and ('s, 'r) _menhir_cell1_selector_dec = 
    | MenhirCell1_selector_dec of 's * ('s, 'r) _menhir_state * (T.t)
  
  and ('s, 'r) _menhir_cell1_sort = 
    | MenhirCell1_sort of 's * ('s, 'r) _menhir_state * (T.t)
  
  and ('s, 'r) _menhir_cell1_sort_dec = 
    | MenhirCell1_sort_dec of 's * ('s, 'r) _menhir_state * (I.t * int)
  
  and ('s, 'r) _menhir_cell1_sorted_var = 
    | MenhirCell1_sorted_var of 's * ('s, 'r) _menhir_state * (T.t)
  
  and ('s, 'r) _menhir_cell1_term = 
    | MenhirCell1_term of 's * ('s, 'r) _menhir_state * (T.t)
  
  and ('s, 'r) _menhir_cell1_var_binding = 
    | MenhirCell1_var_binding of 's * ('s, 'r) _menhir_state * (T.t)
  
  and ('s, 'r) _menhir_cell1_AS = 
    | MenhirCell1_AS of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_ASSERT = 
    | MenhirCell0_ASSERT of 's * Lexing.position * Lexing.position
  
  and ('s, 'r) _menhir_cell1_ATTRIBUTE = 
    | MenhirCell1_ATTRIBUTE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_CHECK_SAT_ASSUMING = 
    | MenhirCell0_CHECK_SAT_ASSUMING of 's * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_CLOSE = 
    | MenhirCell0_CLOSE of 's * Lexing.position
  
  and 's _menhir_cell0_DECLARE_CONST = 
    | MenhirCell0_DECLARE_CONST of 's * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_DECLARE_DATATYPE = 
    | MenhirCell0_DECLARE_DATATYPE of 's * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_DECLARE_DATATYPES = 
    | MenhirCell0_DECLARE_DATATYPES of 's * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_DECLARE_FUN = 
    | MenhirCell0_DECLARE_FUN of 's * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_DEFINE_FUN = 
    | MenhirCell0_DEFINE_FUN of 's * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_DEFINE_FUNS_REC = 
    | MenhirCell0_DEFINE_FUNS_REC of 's * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_DEFINE_FUN_REC = 
    | MenhirCell0_DEFINE_FUN_REC of 's * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_DEFINE_SORT = 
    | MenhirCell0_DEFINE_SORT of 's * Lexing.position * Lexing.position
  
  and ('s, 'r) _menhir_cell1_EXISTS = 
    | MenhirCell1_EXISTS of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position
  
  and ('s, 'r) _menhir_cell1_FORALL = 
    | MenhirCell1_FORALL of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_GET_INFO = 
    | MenhirCell0_GET_INFO of 's * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_GET_VALUE = 
    | MenhirCell0_GET_VALUE of 's * Lexing.position * Lexing.position
  
  and ('s, 'r) _menhir_cell1_KEYWORD = 
    | MenhirCell1_KEYWORD of 's * ('s, 'r) _menhir_state * (
# 9 "src/languages/smtlib2/v2.6/script/tokens.mly"
       (string)
# 767 "src/languages/smtlib2/v2.6/script/parser.ml"
  ) * Lexing.position * Lexing.position
  
  and ('s, 'r) _menhir_cell1_LET = 
    | MenhirCell1_LET of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position
  
  and ('s, 'r) _menhir_cell1_MATCH = 
    | MenhirCell1_MATCH of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position
  
  and ('s, 'r) _menhir_cell1_OPEN = 
    | MenhirCell1_OPEN of 's * ('s, 'r) _menhir_state * Lexing.position
  
  and 's _menhir_cell0_OPEN = 
    | MenhirCell0_OPEN of 's * Lexing.position
  
  and ('s, 'r) _menhir_cell1_PAR = 
    | MenhirCell1_PAR of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_SET_INFO = 
    | MenhirCell0_SET_INFO of 's * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_SET_OPTION = 
    | MenhirCell0_SET_OPTION of 's * Lexing.position * Lexing.position
  
  and ('s, 'r) _menhir_cell1_SYMBOL = 
    | MenhirCell1_SYMBOL of 's * ('s, 'r) _menhir_state * (
# 9 "src/languages/smtlib2/v2.6/script/tokens.mly"
       (string)
# 795 "src/languages/smtlib2/v2.6/script/parser.ml"
  ) * Lexing.position * Lexing.position
  
  and 's _menhir_cell0_SYMBOL = 
    | MenhirCell0_SYMBOL of 's * (
# 9 "src/languages/smtlib2/v2.6/script/tokens.mly"
       (string)
# 802 "src/languages/smtlib2/v2.6/script/parser.ml"
  ) * Lexing.position * Lexing.position
  
  and ('s, 'r) _menhir_cell1_UNDERSCORE = 
    | MenhirCell1_UNDERSCORE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position
  
  and _menhir_box_term = 
    | MenhirBox_term of (T.t) [@@unboxed]
  
  and _menhir_box_input = 
    | MenhirBox_input of (S.t option) [@@unboxed]
  
  and _menhir_box_file = 
    | MenhirBox_file of (S.t list) [@@unboxed]
  
  let _menhir_action_003 =
    fun _endpos_a_ _endpos_s_ _startpos_s_ a s ->
      let _endpos = _endpos_a_ in
      let _startpos = _startpos_s_ in
      (
# 143 "src/languages/smtlib2/v2.6/script/parser.mly"
    (
      let t =
        let loc = L.mk_pos _startpos_s_ _endpos_s_ in
        T.const ~loc I.(mk attr s)
      in
      match a with
      | None -> t
      | Some t' ->
        let loc = L.mk_pos _startpos _endpos in
        T.apply ~loc t [t']
    )
# 834 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_004 =
    fun v ->
      (
# 134 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( v )
# 842 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_005 =
    fun _endpos_v_ _startpos_v_ v ->
      let _endpos = _endpos_v_ in
      let _startpos = _startpos_v_ in
      (
# 136 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.const ~loc I.(mk attr v) )
# 852 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_006 =
    fun _endpos__3_ _startpos__1_ l ->
      let _endpos = _endpos__3_ in
      let _startpos = _startpos__1_ in
      (
# 138 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.sexpr ~loc l )
# 862 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_007 =
    fun _endpos__4_ _startpos__1_ t ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 358 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.assert_ ~loc t )
# 872 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_008 =
    fun _endpos__3_ _startpos__1_ ->
      let _endpos = _endpos__3_ in
      let _startpos = _startpos__1_ in
      (
# 360 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.check_sat ~loc [] )
# 882 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_009 =
    fun _endpos__6_ _startpos__1_ l ->
      let _endpos = _endpos__6_ in
      let _startpos = _startpos__1_ in
      (
# 362 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.check_sat ~loc l )
# 892 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_010 =
    fun _endpos__5_ _startpos__1_ s ty ->
      let _endpos = _endpos__5_ in
      let _startpos = _startpos__1_ in
      (
# 364 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.fun_decl ~loc I.(mk term s) [] [] ty )
# 902 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_011 =
    fun _endpos__5_ _startpos__1_ d s ->
      let _endpos = _endpos__5_ in
      let _startpos = _startpos__1_ in
      (
# 366 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let vars, constructors = d in
      let loc = L.mk_pos _startpos _endpos in
      S.datatypes ~loc [I.(mk sort s), vars, constructors] )
# 914 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_012 =
    fun _endpos__8_ _endpos__9_ _startpos__1_ _startpos__3_ l1 l2 ->
      let _endpos = _endpos__9_ in
      let _startpos = _startpos__1_ in
      (
# 370 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let res =
        try
          List.map2 (fun (s, _) (vars, constructors) -> s, vars, constructors) l1 l2
        with Invalid_argument _ ->
          let loc = L.mk_pos _startpos__3_ _endpos__8_ in
          mismatched_lists ~loc
            (l1, "sort declaration", "sort declarations")
            (l2, "datatype definition", "datatype definitions")
      in
      let loc = L.mk_pos _startpos _endpos in
      S.datatypes ~loc res )
# 934 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_013 =
    fun _endpos__8_ _startpos__1_ args s ty ->
      let _endpos = _endpos__8_ in
      let _startpos = _startpos__1_ in
      (
# 382 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let id = I.(mk term s) in
      let loc = L.mk_pos _startpos _endpos in
      S.fun_decl ~loc id [] args ty )
# 946 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_014 =
    fun _endpos__5_ _startpos__1_ n s ->
      let _endpos = _endpos__5_ in
      let _startpos = _startpos__1_ in
      (
# 386 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let id = I.(mk sort s) in
      let loc = L.mk_pos _startpos _endpos in
      S.type_decl ~loc id (int_of_string n) )
# 958 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_015 =
    fun _endpos__4_ _startpos__1_ f ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 390 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let id, vars, args, ret, body = f in
      let loc = L.mk_pos _startpos _endpos in
      S.fun_def ~loc id vars args ret body )
# 970 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_016 =
    fun _endpos__4_ _startpos__1_ f ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 394 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let id, vars, args, ret, body = f in
      let loc = L.mk_pos _startpos _endpos in
      S.funs_def_rec ~loc [id, vars, args, ret, body] )
# 982 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_017 =
    fun _endpos__8_ _endpos__9_ _startpos__1_ _startpos__3_ l1 l2 ->
      let _endpos = _endpos__9_ in
      let _startpos = _startpos__1_ in
      (
# 400 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let res =
        try List.map2 (fun (id, vars, args, ret) body -> id, vars, args, ret, body) l1 l2
        with Invalid_argument _ ->
          let loc = L.mk_pos _startpos__3_ _endpos__8_ in
          mismatched_lists ~loc
            (l1, "function declaration", "function declarations")
            (l2, "function body", "function bodies")
      in
      let loc = L.mk_pos _startpos _endpos in
      S.funs_def_rec ~loc res )
# 1001 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_018 =
    fun _endpos__8_ _startpos__1_ args s ty ->
      let _endpos = _endpos__8_ in
      let _startpos = _startpos__1_ in
      (
# 411 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let id = I.(mk sort s) in
      let l = List.map I.(mk sort) args in
      let loc = L.mk_pos _startpos _endpos in
      S.type_def ~loc id l ty )
# 1014 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_019 =
    fun _endpos__4_ _startpos__1_ s ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 416 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in
      S.echo ~loc s )
# 1025 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_020 =
    fun _endpos__3_ _startpos__1_ ->
      let _endpos = _endpos__3_ in
      let _startpos = _startpos__1_ in
      (
# 420 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.exit ~loc () )
# 1035 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_021 =
    fun _endpos__3_ _startpos__1_ ->
      let _endpos = _endpos__3_ in
      let _startpos = _startpos__1_ in
      (
# 423 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.get_assertions ~loc () )
# 1045 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_022 =
    fun _endpos__3_ _startpos__1_ ->
      let _endpos = _endpos__3_ in
      let _startpos = _startpos__1_ in
      (
# 425 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.get_assignment ~loc () )
# 1055 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_023 =
    fun _endpos__4_ _startpos__1_ i ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 427 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.get_info ~loc i )
# 1065 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_024 =
    fun _endpos__3_ _startpos__1_ ->
      let _endpos = _endpos__3_ in
      let _startpos = _startpos__1_ in
      (
# 429 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.get_model ~loc () )
# 1075 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_025 =
    fun _endpos__4_ _startpos__1_ k ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 431 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.get_option ~loc k )
# 1085 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_026 =
    fun _endpos__3_ _startpos__1_ ->
      let _endpos = _endpos__3_ in
      let _startpos = _startpos__1_ in
      (
# 433 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.get_proof ~loc () )
# 1095 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_027 =
    fun _endpos__3_ _startpos__1_ ->
      let _endpos = _endpos__3_ in
      let _startpos = _startpos__1_ in
      (
# 435 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.get_unsat_assumptions ~loc () )
# 1105 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_028 =
    fun _endpos__3_ _startpos__1_ ->
      let _endpos = _endpos__3_ in
      let _startpos = _startpos__1_ in
      (
# 437 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.get_unsat_core ~loc () )
# 1115 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_029 =
    fun _endpos__6_ _startpos__1_ l ->
      let _endpos = _endpos__6_ in
      let _startpos = _startpos__1_ in
      (
# 439 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.get_value ~loc l )
# 1125 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_030 =
    fun _endpos__4_ _startpos__1_ n ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 442 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.pop ~loc (int_of_string n) )
# 1135 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_031 =
    fun _endpos__4_ _startpos__1_ n ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 444 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.push ~loc (int_of_string n) )
# 1145 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_032 =
    fun _endpos__3_ _startpos__1_ ->
      let _endpos = _endpos__3_ in
      let _startpos = _startpos__1_ in
      (
# 446 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.reset ~loc () )
# 1155 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_033 =
    fun _endpos__3_ _startpos__1_ ->
      let _endpos = _endpos__3_ in
      let _startpos = _startpos__1_ in
      (
# 448 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.reset_assertions ~loc () )
# 1165 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_034 =
    fun _endpos__4_ _startpos__1_ c ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 451 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.set_info ~loc c )
# 1175 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_035 =
    fun _endpos__4_ _startpos__1_ s ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 453 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.set_logic ~loc s )
# 1185 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_036 =
    fun _endpos__4_ _startpos__1_ c ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 455 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in S.set_option ~loc c )
# 1195 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t))
  
  let _menhir_action_037 =
    fun a ->
      (
# 278 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( a )
# 1203 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_038 =
    fun l s ->
      (
# 299 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( (I.mk I.term s), l )
# 1211 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (I.t * T.t list))
  
  let _menhir_action_039 =
    fun l ->
      (
# 310 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( [], l )
# 1219 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list * (I.t * T.t list) list))
  
  let _menhir_action_040 =
    fun l vars ->
      (
# 312 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( vars, l )
# 1227 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list * (I.t * T.t list) list))
  
  let _menhir_action_041 =
    fun _endpos_s_ _startpos_s_ s ->
      let _endpos = _endpos_s_ in
      let _startpos = _startpos_s_ in
      (
# 306 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.const ~loc I.(mk sort s) )
# 1237 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_042 =
    fun l ->
      (
# 460 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( l )
# 1245 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t list))
  
  let _menhir_action_043 =
    fun args ret s ->
      (
# 317 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( I.(mk term s), [], args, ret )
# 1253 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (I.t * T.t list * T.t list * T.t))
  
  let _menhir_action_044 =
    fun args body ret s ->
      (
# 321 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( I.(mk term s), [], args, ret, body )
# 1261 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (I.t * T.t list * T.t list * T.t * T.t))
  
  let _menhir_action_045 =
    fun s ->
      (
# 116 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( fun ns -> I.mk ns s )
# 1269 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (I.namespace -> I.t))
  
  let _menhir_action_046 =
    fun l s ->
      (
# 118 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( fun ns -> I.indexed ns s l )
# 1277 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (I.namespace -> I.t))
  
  let _menhir_action_047 =
    fun s ->
      (
# 108 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( s )
# 1285 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_048 =
    fun s ->
      (
# 108 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( s )
# 1293 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_049 =
    fun s ->
      (
# 111 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( s )
# 1301 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_050 =
    fun s ->
      (
# 244 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( s )
# 1309 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_051 =
    fun () ->
      (
# 465 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( None )
# 1317 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t option))
  
  let _menhir_action_052 =
    fun c ->
      (
# 467 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( Some c )
# 1325 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t option))
  
  let _menhir_action_053 =
    fun () ->
      (
# 216 "<standard.mly>"
    ( [] )
# 1333 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string list))
  
  let _menhir_action_054 =
    fun x xs ->
      (
# 219 "<standard.mly>"
    ( x :: xs )
# 1341 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string list))
  
  let _menhir_action_055 =
    fun () ->
      (
# 216 "<standard.mly>"
    ( [] )
# 1349 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t list))
  
  let _menhir_action_056 =
    fun x xs ->
      (
# 219 "<standard.mly>"
    ( x :: xs )
# 1357 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (S.t list))
  
  let _menhir_action_057 =
    fun () ->
      (
# 216 "<standard.mly>"
    ( [] )
# 1365 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_058 =
    fun x xs ->
      (
# 219 "<standard.mly>"
    ( x :: xs )
# 1373 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_059 =
    fun () ->
      (
# 216 "<standard.mly>"
    ( [] )
# 1381 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_060 =
    fun x xs ->
      (
# 219 "<standard.mly>"
    ( x :: xs )
# 1389 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_061 =
    fun () ->
      (
# 216 "<standard.mly>"
    ( [] )
# 1397 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_062 =
    fun x xs ->
      (
# 219 "<standard.mly>"
    ( x :: xs )
# 1405 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_063 =
    fun () ->
      (
# 216 "<standard.mly>"
    ( [] )
# 1413 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_064 =
    fun x xs ->
      (
# 219 "<standard.mly>"
    ( x :: xs )
# 1421 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_065 =
    fun () ->
      (
# 216 "<standard.mly>"
    ( [] )
# 1429 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_066 =
    fun x xs ->
      (
# 219 "<standard.mly>"
    ( x :: xs )
# 1437 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_067 =
    fun p t ->
      (
# 204 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( p, t )
# 1445 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t * T.t))
  
  let _menhir_action_068 =
    fun x ->
      (
# 228 "<standard.mly>"
    ( [ x ] )
# 1453 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_069 =
    fun x xs ->
      (
# 231 "<standard.mly>"
    ( x :: xs )
# 1461 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_070 =
    fun x ->
      (
# 228 "<standard.mly>"
    ( [ x ] )
# 1469 "src/languages/smtlib2/v2.6/script/parser.ml"
       : ((I.t * T.t list) list))
  
  let _menhir_action_071 =
    fun x xs ->
      (
# 231 "<standard.mly>"
    ( x :: xs )
# 1477 "src/languages/smtlib2/v2.6/script/parser.ml"
       : ((I.t * T.t list) list))
  
  let _menhir_action_072 =
    fun x ->
      (
# 228 "<standard.mly>"
    ( [ x ] )
# 1485 "src/languages/smtlib2/v2.6/script/parser.ml"
       : ((T.t list * (I.t * T.t list) list) list))
  
  let _menhir_action_073 =
    fun x xs ->
      (
# 231 "<standard.mly>"
    ( x :: xs )
# 1493 "src/languages/smtlib2/v2.6/script/parser.ml"
       : ((T.t list * (I.t * T.t list) list) list))
  
  let _menhir_action_074 =
    fun x ->
      (
# 228 "<standard.mly>"
    ( [ x ] )
# 1501 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_075 =
    fun x xs ->
      (
# 231 "<standard.mly>"
    ( x :: xs )
# 1509 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_076 =
    fun x ->
      (
# 228 "<standard.mly>"
    ( [ x ] )
# 1517 "src/languages/smtlib2/v2.6/script/parser.ml"
       : ((I.t * T.t list * T.t list * T.t) list))
  
  let _menhir_action_077 =
    fun x xs ->
      (
# 231 "<standard.mly>"
    ( x :: xs )
# 1525 "src/languages/smtlib2/v2.6/script/parser.ml"
       : ((I.t * T.t list * T.t list * T.t) list))
  
  let _menhir_action_078 =
    fun x ->
      (
# 228 "<standard.mly>"
    ( [ x ] )
# 1533 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string list))
  
  let _menhir_action_079 =
    fun x xs ->
      (
# 231 "<standard.mly>"
    ( x :: xs )
# 1541 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string list))
  
  let _menhir_action_080 =
    fun x ->
      (
# 228 "<standard.mly>"
    ( [ x ] )
# 1549 "src/languages/smtlib2/v2.6/script/parser.ml"
       : ((T.t * T.t) list))
  
  let _menhir_action_081 =
    fun x xs ->
      (
# 231 "<standard.mly>"
    ( x :: xs )
# 1557 "src/languages/smtlib2/v2.6/script/parser.ml"
       : ((T.t * T.t) list))
  
  let _menhir_action_082 =
    fun x ->
      (
# 228 "<standard.mly>"
    ( [ x ] )
# 1565 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_083 =
    fun x xs ->
      (
# 231 "<standard.mly>"
    ( x :: xs )
# 1573 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_084 =
    fun x ->
      (
# 228 "<standard.mly>"
    ( [ x ] )
# 1581 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_085 =
    fun x xs ->
      (
# 231 "<standard.mly>"
    ( x :: xs )
# 1589 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_086 =
    fun x ->
      (
# 228 "<standard.mly>"
    ( [ x ] )
# 1597 "src/languages/smtlib2/v2.6/script/parser.ml"
       : ((I.t * int) list))
  
  let _menhir_action_087 =
    fun x xs ->
      (
# 231 "<standard.mly>"
    ( x :: xs )
# 1605 "src/languages/smtlib2/v2.6/script/parser.ml"
       : ((I.t * int) list))
  
  let _menhir_action_088 =
    fun x ->
      (
# 228 "<standard.mly>"
    ( [ x ] )
# 1613 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_089 =
    fun x xs ->
      (
# 231 "<standard.mly>"
    ( x :: xs )
# 1621 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_090 =
    fun x ->
      (
# 228 "<standard.mly>"
    ( [ x ] )
# 1629 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_091 =
    fun x xs ->
      (
# 231 "<standard.mly>"
    ( x :: xs )
# 1637 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_092 =
    fun x ->
      (
# 228 "<standard.mly>"
    ( [ x ] )
# 1645 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_093 =
    fun x xs ->
      (
# 231 "<standard.mly>"
    ( x :: xs )
# 1653 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t list))
  
  let _menhir_action_094 =
    fun _endpos_s_ _startpos_s_ s ->
      let _endpos = _endpos_s_ in
      let _startpos = _startpos_s_ in
      (
# 335 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in
      match s with
      | "not" ->
        T.const ~loc I.(mk term s)
      | _ ->
        let msg = Format.dprintf "@[<v>@[<hov>%a@]@ Hint: @[<hov>%a@]@]"
          Format.pp_print_text "expected the 'not' symbol at that point."
          Format.pp_print_text
           "check-sat-assuming only accepts a list of terms \
            of the form 'p' or '(not p)', where p is a boolean literal."
        in
        raise (L.Syntax_error (loc, `Regular msg)) )
# 1674 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_095 =
    fun () ->
      (
# 111 "<standard.mly>"
    ( None )
# 1682 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t option))
  
  let _menhir_action_096 =
    fun x ->
      (
# 114 "<standard.mly>"
    ( Some x )
# 1690 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t option))
  
  let _menhir_action_097 =
    fun c ->
      (
# 197 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( c )
# 1698 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_098 =
    fun _endpos__4_ _startpos__1_ args f ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 199 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.apply ~loc f args )
# 1708 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_099 =
    fun _endpos_s_ _startpos_s_ s ->
      let _endpos = _endpos_s_ in
      let _startpos = _startpos_s_ in
      (
# 192 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.const ~loc I.(mk term s) )
# 1718 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_100 =
    fun s ->
      (
# 351 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( s )
# 1726 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_101 =
    fun _endpos__4_ _startpos__1_ f s ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 353 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.apply ~loc f [s] )
# 1736 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_102 =
    fun s ->
      (
# 326 "src/languages/smtlib2/v2.6/script/parser.mly"
                     ( s )
# 1744 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_103 =
    fun _endpos_s_ _startpos_s_ s ->
      let _endpos = _endpos_s_ in
      let _startpos = _startpos_s_ in
      (
# 162 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in `NoAs (T.const ~loc (s I.term)) )
# 1754 "src/languages/smtlib2/v2.6/script/parser.ml"
       : ([ `As of T.t * T.t * L.t | `NoAs of T.t ]))
  
  let _menhir_action_104 =
    fun _endpos__5_ _endpos_s_ _startpos__1_ _startpos_s_ s ty ->
      let _endpos = _endpos__5_ in
      let _startpos = _startpos__1_ in
      (
# 164 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos_s_ _endpos_s_ in
      let as_loc = L.mk_pos _startpos _endpos in
      `As (T.const ~loc (s I.term), ty, as_loc) )
# 1766 "src/languages/smtlib2/v2.6/script/parser.ml"
       : ([ `As of T.t * T.t * L.t | `NoAs of T.t ]))
  
  let _menhir_action_105 =
    fun () ->
      (
# 52 "src/languages/smtlib2/v2.6/script/parser.mly"
               ( "_" )
# 1774 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_106 =
    fun () ->
      (
# 53 "src/languages/smtlib2/v2.6/script/parser.mly"
              ( "!" )
# 1782 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_107 =
    fun () ->
      (
# 54 "src/languages/smtlib2/v2.6/script/parser.mly"
       ( "as" )
# 1790 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_108 =
    fun () ->
      (
# 55 "src/languages/smtlib2/v2.6/script/parser.mly"
        ( "let" )
# 1798 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_109 =
    fun () ->
      (
# 56 "src/languages/smtlib2/v2.6/script/parser.mly"
           ( "exists" )
# 1806 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_110 =
    fun () ->
      (
# 57 "src/languages/smtlib2/v2.6/script/parser.mly"
           ( "forall" )
# 1814 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_111 =
    fun () ->
      (
# 58 "src/languages/smtlib2/v2.6/script/parser.mly"
          ( "match" )
# 1822 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_112 =
    fun () ->
      (
# 59 "src/languages/smtlib2/v2.6/script/parser.mly"
        ( "par" )
# 1830 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_113 =
    fun () ->
      (
# 60 "src/languages/smtlib2/v2.6/script/parser.mly"
           ( "assert" )
# 1838 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_114 =
    fun () ->
      (
# 61 "src/languages/smtlib2/v2.6/script/parser.mly"
              ( "check-sat" )
# 1846 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_115 =
    fun () ->
      (
# 62 "src/languages/smtlib2/v2.6/script/parser.mly"
                       ( "check-sat-assuming" )
# 1854 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_116 =
    fun () ->
      (
# 63 "src/languages/smtlib2/v2.6/script/parser.mly"
                  ( "declare-const" )
# 1862 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_117 =
    fun () ->
      (
# 64 "src/languages/smtlib2/v2.6/script/parser.mly"
                     ( "declare-datatype" )
# 1870 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_118 =
    fun () ->
      (
# 65 "src/languages/smtlib2/v2.6/script/parser.mly"
                      ( "declare-datatypes" )
# 1878 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_119 =
    fun () ->
      (
# 66 "src/languages/smtlib2/v2.6/script/parser.mly"
                ( "declare-fun" )
# 1886 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_120 =
    fun () ->
      (
# 67 "src/languages/smtlib2/v2.6/script/parser.mly"
                 ( "declare-sort" )
# 1894 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_121 =
    fun () ->
      (
# 68 "src/languages/smtlib2/v2.6/script/parser.mly"
               ( "define-fun" )
# 1902 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_122 =
    fun () ->
      (
# 69 "src/languages/smtlib2/v2.6/script/parser.mly"
                   ( "define-fun-rec" )
# 1910 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_123 =
    fun () ->
      (
# 70 "src/languages/smtlib2/v2.6/script/parser.mly"
                    ( "define-funs-rec" )
# 1918 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_124 =
    fun () ->
      (
# 71 "src/languages/smtlib2/v2.6/script/parser.mly"
                ( "define-sort" )
# 1926 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_125 =
    fun () ->
      (
# 72 "src/languages/smtlib2/v2.6/script/parser.mly"
         ( "echo" )
# 1934 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_126 =
    fun () ->
      (
# 73 "src/languages/smtlib2/v2.6/script/parser.mly"
         ( "exit" )
# 1942 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_127 =
    fun () ->
      (
# 74 "src/languages/smtlib2/v2.6/script/parser.mly"
                   ( "get-assertions" )
# 1950 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_128 =
    fun () ->
      (
# 75 "src/languages/smtlib2/v2.6/script/parser.mly"
                   ( "get-assignment" )
# 1958 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_129 =
    fun () ->
      (
# 76 "src/languages/smtlib2/v2.6/script/parser.mly"
             ( "get-info" )
# 1966 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_130 =
    fun () ->
      (
# 77 "src/languages/smtlib2/v2.6/script/parser.mly"
              ( "get-model" )
# 1974 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_131 =
    fun () ->
      (
# 78 "src/languages/smtlib2/v2.6/script/parser.mly"
               ( "get-option" )
# 1982 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_132 =
    fun () ->
      (
# 79 "src/languages/smtlib2/v2.6/script/parser.mly"
              ( "get-proof" )
# 1990 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_133 =
    fun () ->
      (
# 80 "src/languages/smtlib2/v2.6/script/parser.mly"
                          ( "get-unsat-assumptions" )
# 1998 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_134 =
    fun () ->
      (
# 81 "src/languages/smtlib2/v2.6/script/parser.mly"
                   ( "get-unsat-core" )
# 2006 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_135 =
    fun () ->
      (
# 82 "src/languages/smtlib2/v2.6/script/parser.mly"
              ( "get-value" )
# 2014 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_136 =
    fun () ->
      (
# 83 "src/languages/smtlib2/v2.6/script/parser.mly"
        ( "pop" )
# 2022 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_137 =
    fun () ->
      (
# 84 "src/languages/smtlib2/v2.6/script/parser.mly"
         ( "push" )
# 2030 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_138 =
    fun () ->
      (
# 85 "src/languages/smtlib2/v2.6/script/parser.mly"
          ( "reset" )
# 2038 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_139 =
    fun () ->
      (
# 86 "src/languages/smtlib2/v2.6/script/parser.mly"
                     ( "reset-assertions" )
# 2046 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_140 =
    fun () ->
      (
# 87 "src/languages/smtlib2/v2.6/script/parser.mly"
             ( "set-info" )
# 2054 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_141 =
    fun () ->
      (
# 88 "src/languages/smtlib2/v2.6/script/parser.mly"
              ( "set-logic" )
# 2062 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_142 =
    fun () ->
      (
# 89 "src/languages/smtlib2/v2.6/script/parser.mly"
               ( "set-option" )
# 2070 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (string))
  
  let _menhir_action_143 =
    fun c ->
      (
# 94 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( c )
# 2078 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_144 =
    fun _endpos_s_ _startpos_s_ s ->
      let _endpos = _endpos_s_ in
      let _startpos = _startpos_s_ in
      (
# 96 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.const ~loc I.(mk term s) )
# 2088 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_145 =
    fun _endpos_s_ _startpos_s_ s ->
      let _endpos = _endpos_s_ in
      let _startpos = _startpos_s_ in
      (
# 98 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.const ~loc I.(mk term s) )
# 2098 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_146 =
    fun _endpos_s_ _startpos_s_ s ->
      let _endpos = _endpos_s_ in
      let _startpos = _startpos_s_ in
      (
# 100 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.const ~loc I.(mk term s) )
# 2108 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_147 =
    fun _endpos__3_ _startpos__1_ l ->
      let _endpos = _endpos__3_ in
      let _startpos = _startpos__1_ in
      (
# 102 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.sexpr ~loc l )
# 2118 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_148 =
    fun _endpos__4_ _startpos__1_ s ty ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 289 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let f =
      let loc = L.mk_pos _startpos _endpos in
      T.const ~loc (I.mk I.term s)
    in
    let loc = L.mk_pos _startpos _endpos in
    T.colon ~loc f ty )
# 2133 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_149 =
    fun _endpos_s_ _startpos_s_ s ->
      let _endpos = _endpos_s_ in
      let _startpos = _startpos_s_ in
      (
# 123 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.const ~loc (s I.sort) )
# 2143 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_150 =
    fun _endpos__4_ _endpos_f_ _startpos__1_ _startpos_f_ args f ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 125 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let c =
        let loc = L.mk_pos _startpos_f_ _endpos_f_ in
        T.const ~loc (f I.sort)
      in
      let loc = L.mk_pos _startpos _endpos in T.apply ~loc c args )
# 2157 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_151 =
    fun n s ->
      (
# 283 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( I.(mk sort s), int_of_string n
      (* shouldn't raise because of the definition of numeral in lexer *) )
# 2166 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (I.t * int))
  
  let _menhir_action_152 =
    fun _endpos__4_ _endpos_s_ _startpos__1_ _startpos_s_ s ty ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 180 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let c =
        let loc = L.mk_pos _startpos_s_ _endpos_s_ in
        T.const ~loc I.(mk term s)
      in
      let loc = L.mk_pos _startpos _endpos in T.colon ~loc c ty )
# 2180 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_153 =
    fun _endpos_s_ _startpos_s_ s ->
      let _endpos = _endpos_s_ in
      let _startpos = _startpos_s_ in
      (
# 33 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.int ~loc s )
# 2190 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_154 =
    fun _endpos_s_ _startpos_s_ s ->
      let _endpos = _endpos_s_ in
      let _startpos = _startpos_s_ in
      (
# 35 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.real ~loc s )
# 2200 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_155 =
    fun _endpos_s_ _startpos_s_ s ->
      let _endpos = _endpos_s_ in
      let _startpos = _startpos_s_ in
      (
# 37 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.hexa ~loc s )
# 2210 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_156 =
    fun _endpos_s_ _startpos_s_ s ->
      let _endpos = _endpos_s_ in
      let _startpos = _startpos_s_ in
      (
# 39 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.binary ~loc s )
# 2220 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_157 =
    fun _endpos_s_ _startpos_s_ s ->
      let _endpos = _endpos_s_ in
      let _startpos = _startpos_s_ in
      (
# 41 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.str ~loc s )
# 2230 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_158 =
    fun c ->
      (
# 209 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( c )
# 2238 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_159 =
    fun s ->
      (
# 211 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( match s with
      | `NoAs f -> f
      | `As (f, ty, loc) -> T.colon ~loc f ty )
# 2248 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_160 =
    fun _endpos__4_ _startpos__1_ args s ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 215 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in
      match s with
      | `NoAs f -> T.apply ~loc f args
      | `As (f, ty, as_loc) -> T.colon ~loc:as_loc (T.apply ~loc f args) ty )
# 2261 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_161 =
    fun _endpos__7_ _startpos__1_ l t ->
      let _endpos = _endpos__7_ in
      let _startpos = _startpos__1_ in
      (
# 220 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.letand ~loc l t )
# 2271 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_162 =
    fun _endpos__7_ _startpos__1_ l t ->
      let _endpos = _endpos__7_ in
      let _startpos = _startpos__1_ in
      (
# 222 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.forall ~loc l t )
# 2281 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_163 =
    fun _endpos__7_ _startpos__1_ l t ->
      let _endpos = _endpos__7_ in
      let _startpos = _startpos__1_ in
      (
# 224 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.exists ~loc l t )
# 2291 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_164 =
    fun _endpos__7_ _startpos__1_ l t ->
      let _endpos = _endpos__7_ in
      let _startpos = _startpos__1_ in
      (
# 226 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.match_ ~loc t l )
# 2301 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_165 =
    fun _endpos__5_ _startpos__1_ args f ->
      let _endpos = _endpos__5_ in
      let _startpos = _startpos__1_ in
      (
# 228 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let loc = L.mk_pos _startpos _endpos in T.annot ~loc f args )
# 2311 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_action_166 =
    fun _endpos__4_ _endpos_s_ _startpos__1_ _startpos_s_ s t ->
      let _endpos = _endpos__4_ in
      let _startpos = _startpos__1_ in
      (
# 171 "src/languages/smtlib2/v2.6/script/parser.mly"
    ( let c =
        let loc = L.mk_pos _startpos_s_ _endpos_s_ in
        T.const ~loc I.(mk term s)
      in
      let loc = L.mk_pos _startpos _endpos in T.colon ~loc c t )
# 2325 "src/languages/smtlib2/v2.6/script/parser.ml"
       : (T.t))
  
  let _menhir_print_token : token -> string =
    fun _tok ->
      match _tok with
      | Tokens.AS ->
          "AS"
      | Tokens.ASSERT ->
          "ASSERT"
      | Tokens.ATTRIBUTE ->
          "ATTRIBUTE"
      | Tokens.BIN _ ->
          "BIN"
      | Tokens.CHECK_SAT ->
          "CHECK_SAT"
      | Tokens.CHECK_SAT_ASSUMING ->
          "CHECK_SAT_ASSUMING"
      | Tokens.CLOSE ->
          "CLOSE"
      | Tokens.DEC _ ->
          "DEC"
      | Tokens.DECLARE_CONST ->
          "DECLARE_CONST"
      | Tokens.DECLARE_DATATYPE ->
          "DECLARE_DATATYPE"
      | Tokens.DECLARE_DATATYPES ->
          "DECLARE_DATATYPES"
      | Tokens.DECLARE_FUN ->
          "DECLARE_FUN"
      | Tokens.DECLARE_SORT ->
          "DECLARE_SORT"
      | Tokens.DEFINE_FUN ->
          "DEFINE_FUN"
      | Tokens.DEFINE_FUNS_REC ->
          "DEFINE_FUNS_REC"
      | Tokens.DEFINE_FUN_REC ->
          "DEFINE_FUN_REC"
      | Tokens.DEFINE_SORT ->
          "DEFINE_SORT"
      | Tokens.ECHO ->
          "ECHO"
      | Tokens.EOF ->
          "EOF"
      | Tokens.EXISTS ->
          "EXISTS"
      | Tokens.EXIT ->
          "EXIT"
      | Tokens.FORALL ->
          "FORALL"
      | Tokens.GET_ASSERTIONS ->
          "GET_ASSERTIONS"
      | Tokens.GET_ASSIGNMENT ->
          "GET_ASSIGNMENT"
      | Tokens.GET_INFO ->
          "GET_INFO"
      | Tokens.GET_MODEL ->
          "GET_MODEL"
      | Tokens.GET_OPTION ->
          "GET_OPTION"
      | Tokens.GET_PROOF ->
          "GET_PROOF"
      | Tokens.GET_UNSAT_ASSUMPTIONS ->
          "GET_UNSAT_ASSUMPTIONS"
      | Tokens.GET_UNSAT_CORE ->
          "GET_UNSAT_CORE"
      | Tokens.GET_VALUE ->
          "GET_VALUE"
      | Tokens.HEX _ ->
          "HEX"
      | Tokens.KEYWORD _ ->
          "KEYWORD"
      | Tokens.LET ->
          "LET"
      | Tokens.MATCH ->
          "MATCH"
      | Tokens.NUM _ ->
          "NUM"
      | Tokens.OPEN ->
          "OPEN"
      | Tokens.PAR ->
          "PAR"
      | Tokens.POP ->
          "POP"
      | Tokens.PUSH ->
          "PUSH"
      | Tokens.RESET ->
          "RESET"
      | Tokens.RESET_ASSERTIONS ->
          "RESET_ASSERTIONS"
      | Tokens.SET_INFO ->
          "SET_INFO"
      | Tokens.SET_LOGIC ->
          "SET_LOGIC"
      | Tokens.SET_OPTION ->
          "SET_OPTION"
      | Tokens.STR _ ->
          "STR"
      | Tokens.SYMBOL _ ->
          "SYMBOL"
      | Tokens.UNDERSCORE ->
          "UNDERSCORE"
  
  let _menhir_fail : unit -> 'a =
    fun () ->
      Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
      assert false
  
  include struct
    
    [@@@ocaml.warning "-4-37"]
    
    let _menhir_run_483 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_term =
      fun _menhir_stack _v ->
        MenhirBox_term _v
    
    let _menhir_goto_input : type  ttv_stack. ttv_stack -> _ -> _menhir_box_input =
      fun _menhir_stack _v ->
        MenhirBox_input _v
    
    let _menhir_run_435 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_input =
      fun _menhir_stack _v ->
        let c = _v in
        let _v = _menhir_action_052 c in
        _menhir_goto_input _menhir_stack _v
    
    let _menhir_run_321 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_file =
      fun _menhir_stack _v ->
        let l = _v in
        let _v = _menhir_action_042 l in
        MenhirBox_file _v
    
    let rec _menhir_run_325 : type  ttv_stack. (ttv_stack, _menhir_box_file) _menhir_cell1_command -> _ -> _menhir_box_file =
      fun _menhir_stack _v ->
        let MenhirCell1_command (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_056 x xs in
        _menhir_goto_list_command_ _menhir_stack _v _menhir_s
    
    and _menhir_goto_list_command_ : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_file) _menhir_state -> _menhir_box_file =
      fun _menhir_stack _v _menhir_s ->
        match _menhir_s with
        | MenhirState324 ->
            _menhir_run_325 _menhir_stack _v
        | MenhirState000 ->
            _menhir_run_321 _menhir_stack _v
        | _ ->
            _menhir_fail ()
    
    let rec _menhir_run_001 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_file) _menhir_state -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SET_OPTION ->
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_SET_OPTION (_menhir_stack, _startpos, _endpos) in
            let _menhir_s = MenhirState002 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.KEYWORD _v ->
                _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 2)
        | Tokens.SET_LOGIC ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    let (_startpos__1_, s, _endpos__4_) = (_startpos, _v, _endpos_4) in
                    let _v = _menhir_action_035 _endpos__4_ _startpos__1_ s in
                    _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
                | _ ->
                    _eRR 67)
            | _ ->
                _eRR 66)
        | Tokens.SET_INFO ->
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_SET_INFO (_menhir_stack, _startpos, _endpos) in
            let _menhir_s = MenhirState069 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.KEYWORD _v ->
                _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 69)
        | Tokens.RESET_ASSERTIONS ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.CLOSE ->
                let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
                let _tok = _menhir_lexer _menhir_lexbuf in
                let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_7) in
                let _v = _menhir_action_033 _endpos__3_ _startpos__1_ in
                _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
            | _ ->
                _eRR 72)
        | Tokens.RESET ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.CLOSE ->
                let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
                let _tok = _menhir_lexer _menhir_lexbuf in
                let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_9) in
                let _v = _menhir_action_032 _endpos__3_ _startpos__1_ in
                _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
            | _ ->
                _eRR 74)
        | Tokens.PUSH ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.NUM _v ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    let (_startpos__1_, _endpos__4_, n) = (_startpos, _endpos_13, _v) in
                    let _v = _menhir_action_031 _endpos__4_ _startpos__1_ n in
                    _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
                | _ ->
                    _eRR 77)
            | _ ->
                _eRR 76)
        | Tokens.POP ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.NUM _v ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    let (_startpos__1_, _endpos__4_, n) = (_startpos, _endpos_17, _v) in
                    let _v = _menhir_action_030 _endpos__4_ _startpos__1_ n in
                    _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
                | _ ->
                    _eRR 80)
            | _ ->
                _eRR 79)
        | Tokens.GET_VALUE ->
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_GET_VALUE (_menhir_stack, _startpos, _endpos) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
                let _menhir_s = MenhirState083 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.STR _v ->
                    _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.OPEN ->
                    _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                | Tokens.NUM _v ->
                    _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.HEX _v ->
                    _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.DEC _v ->
                    _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.BIN _v ->
                    _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | _ ->
                    _eRR 83)
            | _ ->
                _eRR 82)
        | Tokens.GET_UNSAT_CORE ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.CLOSE ->
                let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
                let _tok = _menhir_lexer _menhir_lexbuf in
                let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_21) in
                let _v = _menhir_action_028 _endpos__3_ _startpos__1_ in
                _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
            | _ ->
                _eRR 175)
        | Tokens.GET_UNSAT_ASSUMPTIONS ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.CLOSE ->
                let _endpos_23 = _menhir_lexbuf.Lexing.lex_curr_p in
                let _tok = _menhir_lexer _menhir_lexbuf in
                let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_23) in
                let _v = _menhir_action_027 _endpos__3_ _startpos__1_ in
                _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
            | _ ->
                _eRR 177)
        | Tokens.GET_PROOF ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.CLOSE ->
                let _endpos_25 = _menhir_lexbuf.Lexing.lex_curr_p in
                let _tok = _menhir_lexer _menhir_lexbuf in
                let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_25) in
                let _v = _menhir_action_026 _endpos__3_ _startpos__1_ in
                _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
            | _ ->
                _eRR 179)
        | Tokens.GET_OPTION ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.KEYWORD _v ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_29 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    let (_startpos__1_, _endpos__4_, k) = (_startpos, _endpos_29, _v) in
                    let _v = _menhir_action_025 _endpos__4_ _startpos__1_ k in
                    _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
                | _ ->
                    _eRR 182)
            | _ ->
                _eRR 181)
        | Tokens.GET_MODEL ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.CLOSE ->
                let _endpos_31 = _menhir_lexbuf.Lexing.lex_curr_p in
                let _tok = _menhir_lexer _menhir_lexbuf in
                let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_31) in
                let _v = _menhir_action_024 _endpos__3_ _startpos__1_ in
                _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
            | _ ->
                _eRR 184)
        | Tokens.GET_INFO ->
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_GET_INFO (_menhir_stack, _startpos, _endpos) in
            let _menhir_s = MenhirState186 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.KEYWORD _v ->
                _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 186)
        | Tokens.GET_ASSIGNMENT ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.CLOSE ->
                let _endpos_34 = _menhir_lexbuf.Lexing.lex_curr_p in
                let _tok = _menhir_lexer _menhir_lexbuf in
                let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_34) in
                let _v = _menhir_action_022 _endpos__3_ _startpos__1_ in
                _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
            | _ ->
                _eRR 190)
        | Tokens.GET_ASSERTIONS ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.CLOSE ->
                let _endpos_36 = _menhir_lexbuf.Lexing.lex_curr_p in
                let _tok = _menhir_lexer _menhir_lexbuf in
                let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_36) in
                let _v = _menhir_action_021 _endpos__3_ _startpos__1_ in
                _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
            | _ ->
                _eRR 192)
        | Tokens.EXIT ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.CLOSE ->
                let _endpos_38 = _menhir_lexbuf.Lexing.lex_curr_p in
                let _tok = _menhir_lexer _menhir_lexbuf in
                let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_38) in
                let _v = _menhir_action_020 _endpos__3_ _startpos__1_ in
                _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
            | _ ->
                _eRR 194)
        | Tokens.ECHO ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.STR _v ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_42 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    let (_startpos__1_, s, _endpos__4_) = (_startpos, _v, _endpos_42) in
                    let _v = _menhir_action_019 _endpos__4_ _startpos__1_ s in
                    _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
                | _ ->
                    _eRR 197)
            | _ ->
                _eRR 196)
        | Tokens.DEFINE_SORT ->
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _startpos_43 = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_DEFINE_SORT (_menhir_stack, _startpos_43, _endpos) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                let _startpos_44 = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos_45 = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos_44, _endpos_45) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    let _startpos_46 = _menhir_lexbuf.Lexing.lex_start_p in
                    let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos_46) in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.SYMBOL _v_47 ->
                        _menhir_run_202 _menhir_stack _menhir_lexbuf _menhir_lexer _v_47 MenhirState201
                    | Tokens.CLOSE ->
                        let _v_48 = _menhir_action_053 () in
                        _menhir_run_204 _menhir_stack _menhir_lexbuf _menhir_lexer _v_48 MenhirState201
                    | _ ->
                        _eRR 201)
                | _ ->
                    _eRR 200)
            | _ ->
                _eRR 199)
        | Tokens.DEFINE_FUN_REC ->
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_DEFINE_FUN_REC (_menhir_stack, _startpos, _endpos) in
            let _menhir_s = MenhirState208 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                _menhir_run_209 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 208)
        | Tokens.DEFINE_FUNS_REC ->
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_DEFINE_FUNS_REC (_menhir_stack, _startpos, _endpos) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
                let _menhir_s = MenhirState220 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                | _ ->
                    _eRR 220)
            | _ ->
                _eRR 219)
        | Tokens.DEFINE_FUN ->
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_DEFINE_FUN (_menhir_stack, _startpos, _endpos) in
            let _menhir_s = MenhirState236 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                _menhir_run_209 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 236)
        | Tokens.DECLARE_SORT ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.NUM _v_56 ->
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.CLOSE ->
                        let _endpos_59 = _menhir_lexbuf.Lexing.lex_curr_p in
                        let _tok = _menhir_lexer _menhir_lexbuf in
                        let (_startpos__1_, s, n, _endpos__5_) = (_startpos, _v, _v_56, _endpos_59) in
                        let _v = _menhir_action_014 _endpos__5_ _startpos__1_ n s in
                        _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
                    | _ ->
                        _eRR 241)
                | _ ->
                    _eRR 240)
            | _ ->
                _eRR 239)
        | Tokens.DECLARE_FUN ->
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _startpos_60 = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_DECLARE_FUN (_menhir_stack, _startpos_60, _endpos) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                let _startpos_61 = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos_62 = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos_61, _endpos_62) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    let _startpos_63 = _menhir_lexbuf.Lexing.lex_start_p in
                    let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos_63) in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.SYMBOL _v_64 ->
                        _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v_64 MenhirState245
                    | Tokens.OPEN ->
                        _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState245
                    | Tokens.CLOSE ->
                        let _v_65 = _menhir_action_063 () in
                        _menhir_run_248 _menhir_stack _menhir_lexbuf _menhir_lexer _v_65 MenhirState245
                    | _ ->
                        _eRR 245)
                | _ ->
                    _eRR 244)
            | _ ->
                _eRR 243)
        | Tokens.DECLARE_DATATYPES ->
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_DECLARE_DATATYPES (_menhir_stack, _startpos, _endpos) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
                let _menhir_s = MenhirState253 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                | _ ->
                    _eRR 253)
            | _ ->
                _eRR 252)
        | Tokens.DECLARE_DATATYPE ->
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_DECLARE_DATATYPE (_menhir_stack, _startpos, _endpos) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos, _endpos) in
                let _menhir_s = MenhirState295 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    _menhir_run_263 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                | _ ->
                    _eRR 295)
            | _ ->
                _eRR 294)
        | Tokens.DECLARE_CONST ->
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_DECLARE_CONST (_menhir_stack, _startpos, _endpos) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos, _endpos) in
                let _menhir_s = MenhirState299 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.OPEN ->
                    _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                | _ ->
                    _eRR 299)
            | _ ->
                _eRR 298)
        | Tokens.CHECK_SAT_ASSUMING ->
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _startpos_75 = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_CHECK_SAT_ASSUMING (_menhir_stack, _startpos_75, _endpos) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                let _startpos_76 = _menhir_lexbuf.Lexing.lex_start_p in
                let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos_76) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState303
                | Tokens.OPEN ->
                    _menhir_run_304 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState303
                | Tokens.CLOSE ->
                    let _v = _menhir_action_057 () in
                    _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _v
                | _ ->
                    _eRR 303)
            | _ ->
                _eRR 302)
        | Tokens.CHECK_SAT ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.CLOSE ->
                let _endpos_78 = _menhir_lexbuf.Lexing.lex_curr_p in
                let _tok = _menhir_lexer _menhir_lexbuf in
                let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_78) in
                let _v = _menhir_action_008 _endpos__3_ _startpos__1_ in
                _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
            | _ ->
                _eRR 316)
        | Tokens.ASSERT ->
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_ASSERT (_menhir_stack, _startpos, _endpos) in
            let _menhir_s = MenhirState318 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.STR _v ->
                _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.OPEN ->
                _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
            | Tokens.NUM _v ->
                _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.HEX _v ->
                _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.DEC _v ->
                _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.BIN _v ->
                _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 318)
        | _ ->
            _eRR 1
    
    and _menhir_run_003 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell1_KEYWORD (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let (_endpos_v_, _startpos_v_, v) = (_endpos_2, _startpos_1, _v_0) in
            let _v = _menhir_action_005 _endpos_v_ _startpos_v_ v in
            _menhir_goto_attribute_value _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_v_ _v _tok
        | Tokens.STR _v_4 ->
            _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState003
        | Tokens.OPEN ->
            let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState003, _startpos_5) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.UNDERSCORE ->
                _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.SYMBOL _v_6 ->
                _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState006
            | Tokens.STR _v_7 ->
                _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState006
            | Tokens.SET_OPTION ->
                _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.SET_LOGIC ->
                _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.SET_INFO ->
                _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.RESET_ASSERTIONS ->
                _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.RESET ->
                _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.PUSH ->
                _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.POP ->
                _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.PAR ->
                _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.OPEN ->
                _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.NUM _v_8 ->
                _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState006
            | Tokens.MATCH ->
                _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.LET ->
                _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.KEYWORD _v_9 ->
                _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState006
            | Tokens.HEX _v_10 ->
                _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState006
            | Tokens.GET_VALUE ->
                _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.GET_UNSAT_CORE ->
                _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.GET_UNSAT_ASSUMPTIONS ->
                _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.GET_PROOF ->
                _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.GET_OPTION ->
                _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.GET_MODEL ->
                _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.GET_INFO ->
                _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.GET_ASSIGNMENT ->
                _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.GET_ASSERTIONS ->
                _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.FORALL ->
                _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.EXIT ->
                _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.EXISTS ->
                _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.ECHO ->
                _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.DEFINE_SORT ->
                _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.DEFINE_FUN_REC ->
                _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.DEFINE_FUNS_REC ->
                _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.DEFINE_FUN ->
                _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.DECLARE_SORT ->
                _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.DECLARE_FUN ->
                _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.DECLARE_DATATYPES ->
                _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.DECLARE_DATATYPE ->
                _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.DECLARE_CONST ->
                _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.DEC _v_11 ->
                _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState006
            | Tokens.CHECK_SAT_ASSUMING ->
                _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.CHECK_SAT ->
                _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.BIN _v_12 ->
                _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState006
            | Tokens.ATTRIBUTE ->
                _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.ASSERT ->
                _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.AS ->
                _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState006
            | Tokens.CLOSE ->
                let _v_13 = _menhir_action_059 () in
                _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13
            | _ ->
                _eRR 6)
        | Tokens.NUM _v_14 ->
            _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState003
        | Tokens.HEX _v_15 ->
            _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState003
        | Tokens.DEC _v_16 ->
            _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState003
        | Tokens.BIN _v_17 ->
            _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState003
        | Tokens.CLOSE | Tokens.KEYWORD _ ->
            let _v = _menhir_action_095 () in
            _menhir_goto_option_attribute_value_ _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
        | _ ->
            _eRR 3
    
    and _menhir_goto_attribute_value : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_KEYWORD -> _ -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
        let (_endpos_x_, x) = (_endpos, _v) in
        let _v = _menhir_action_096 x in
        _menhir_goto_option_attribute_value_ _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_x_ _v _tok
    
    and _menhir_goto_option_attribute_value_ : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_KEYWORD -> _ -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
        let MenhirCell1_KEYWORD (_menhir_stack, _menhir_s, s, _startpos_s_, _endpos_s_) = _menhir_stack in
        let (_endpos_a_, a) = (_endpos, _v) in
        let _v = _menhir_action_003 _endpos_a_ _endpos_s_ _startpos_s_ a s in
        _menhir_goto_attribute _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_attribute : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState469 ->
            _menhir_run_165 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState165 ->
            _menhir_run_165 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState162 ->
            _menhir_run_165 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState334 ->
            _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState328 ->
            _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState069 ->
            _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState002 ->
            _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_165 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.KEYWORD _v_0 ->
            let _menhir_stack = MenhirCell1_attribute (_menhir_stack, _menhir_s, _v) in
            _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState165
        | Tokens.CLOSE ->
            let x = _v in
            let _v = _menhir_action_068 x in
            _menhir_goto_nonempty_list_attribute_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 165
    
    and _menhir_goto_nonempty_list_attribute_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState469 ->
            _menhir_run_470 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState165 ->
            _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState162 ->
            _menhir_run_163 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_470 : type  ttv_stack. (((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_ATTRIBUTE, _menhir_box_term) _menhir_cell1_term -> _ -> _ -> _ -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let MenhirCell1_term (_menhir_stack, _, f) = _menhir_stack in
        let MenhirCell1_ATTRIBUTE (_menhir_stack, _, _, _) = _menhir_stack in
        let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
        let (_endpos__5_, args) = (_endpos, _v) in
        let _v = _menhir_action_165 _endpos__5_ _startpos__1_ args f in
        _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_term : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState436 ->
            _menhir_run_483 _menhir_stack _v
        | MenhirState468 ->
            _menhir_run_469 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState465 ->
            _menhir_run_466 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState459 ->
            _menhir_run_460 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState453 ->
            _menhir_run_454 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState444 ->
            _menhir_run_445 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState430 ->
            _menhir_run_431 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState318 ->
            _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState215 ->
            _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState476 ->
            _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState389 ->
            _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState348 ->
            _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState230 ->
            _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState083 ->
            _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState168 ->
            _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState167 ->
            _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState161 ->
            _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState158 ->
            _menhir_run_159 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState152 ->
            _menhir_run_153 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState140 ->
            _menhir_run_141 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState134 ->
            _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState120 ->
            _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState108 ->
            _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_469 : type  ttv_stack. (((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_ATTRIBUTE as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_term) _menhir_state -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_term (_menhir_stack, _menhir_s, _v) in
        match (_tok : MenhirBasics.token) with
        | Tokens.KEYWORD _v_0 ->
            _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState469
        | _ ->
            _eRR 469
    
    and _menhir_run_466 : type  ttv_stack. (((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_EXISTS _menhir_cell0_OPEN, _menhir_box_term) _menhir_cell1_nonempty_list_sorted_var_ _menhir_cell0_CLOSE -> _ -> _ -> _ -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_nonempty_list_sorted_var_ (_menhir_stack, _, l) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_EXISTS (_menhir_stack, _, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__7_, t) = (_endpos, _v) in
            let _v = _menhir_action_163 _endpos__7_ _startpos__1_ l t in
            _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 466
    
    and _menhir_run_460 : type  ttv_stack. (((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_FORALL _menhir_cell0_OPEN, _menhir_box_term) _menhir_cell1_nonempty_list_sorted_var_ _menhir_cell0_CLOSE -> _ -> _ -> _ -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_nonempty_list_sorted_var_ (_menhir_stack, _, l) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_FORALL (_menhir_stack, _, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__7_, t) = (_endpos, _v) in
            let _v = _menhir_action_162 _endpos__7_ _startpos__1_ l t in
            _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 460
    
    and _menhir_run_454 : type  ttv_stack. (((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_LET _menhir_cell0_OPEN, _menhir_box_term) _menhir_cell1_nonempty_list_var_binding_ _menhir_cell0_CLOSE -> _ -> _ -> _ -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_nonempty_list_var_binding_ (_menhir_stack, _, l) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_LET (_menhir_stack, _, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__7_, t) = (_endpos, _v) in
            let _v = _menhir_action_161 _endpos__7_ _startpos__1_ l t in
            _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 454
    
    and _menhir_run_445 : type  ttv_stack. (((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_MATCH as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_term) _menhir_state -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_term (_menhir_stack, _menhir_s, _v) in
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
            let _menhir_s = MenhirState446 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
            | _ ->
                _eRR 446)
        | _ ->
            _eRR 445
    
    and _menhir_run_111 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
        let _menhir_s = MenhirState111 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _menhir_s = MenhirState113 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 113)
        | _ ->
            _eRR 111
    
    and _menhir_run_112 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
        let _v = _menhir_action_099 _endpos_s_ _startpos_s_ s in
        _menhir_goto_pattern_symbol _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_pattern_symbol : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState424 ->
            _menhir_run_309 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState303 ->
            _menhir_run_309 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState311 ->
            _menhir_run_309 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState306 ->
            _menhir_run_309 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState111 ->
            _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState115 ->
            _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState114 ->
            _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState113 ->
            _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_309 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let s = _v in
        let _v = _menhir_action_102 s in
        _menhir_goto_prop_symbol _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_prop_symbol : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState424 ->
            _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState311 ->
            _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState303 ->
            _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState306 ->
            _menhir_run_307 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_310 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let s = _v in
        let _v = _menhir_action_100 s in
        _menhir_goto_prop_literal _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_prop_literal : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_prop_literal (_menhir_stack, _menhir_s, _v) in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState311
        | Tokens.OPEN ->
            _menhir_run_304 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState311
        | Tokens.CLOSE ->
            let _v_1 = _menhir_action_057 () in
            _menhir_run_312 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1
        | _ ->
            _eRR 311
    
    and _menhir_run_304 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos_0, _v) in
            let _v = _menhir_action_094 _endpos_s_ _startpos_s_ s in
            let _menhir_stack = MenhirCell0_not_symbol (_menhir_stack, _v) in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v_0 ->
                _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState306
            | _ ->
                _eRR 306)
        | _ ->
            _eRR 304
    
    and _menhir_run_312 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_prop_literal -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_prop_literal (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_058 x xs in
        _menhir_goto_list_prop_literal_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_goto_list_prop_literal_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState424 ->
            _menhir_run_425 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState303 ->
            _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState311 ->
            _menhir_run_312 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_425 : type  ttv_stack. (ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_CHECK_SAT_ASSUMING _menhir_cell0_OPEN -> _ -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell0_CHECK_SAT_ASSUMING (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (l, _endpos__6_) = (_v, _endpos_0) in
            let _v = _menhir_action_009 _endpos__6_ _startpos__1_ l in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 426
    
    and _menhir_goto_command : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState326 ->
            _menhir_run_435 _menhir_stack _v
        | MenhirState324 ->
            _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState000 ->
            _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_324 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file) _menhir_state -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_command (_menhir_stack, _menhir_s, _v) in
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState324
        | Tokens.EOF ->
            let _v_0 = _menhir_action_055 () in
            _menhir_run_325 _menhir_stack _v_0
        | _ ->
            _eRR 324
    
    and _menhir_run_313 : type  ttv_stack. (ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_CHECK_SAT_ASSUMING _menhir_cell0_OPEN -> _ -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell0_CHECK_SAT_ASSUMING (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (l, _endpos__6_) = (_v, _endpos_0) in
            let _v = _menhir_action_009 _endpos__6_ _startpos__1_ l in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 314
    
    and _menhir_run_307 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_OPEN _menhir_cell0_not_symbol -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_not_symbol (_menhir_stack, f) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (s, _endpos__4_) = (_v, _endpos) in
            let _v = _menhir_action_101 _endpos__4_ _startpos__1_ f s in
            _menhir_goto_prop_literal _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 307
    
    and _menhir_run_119 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let c = _v in
        let _v = _menhir_action_097 c in
        _menhir_goto_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_pattern : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_pattern (_menhir_stack, _menhir_s, _v) in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState120
        | Tokens.STR _v_1 ->
            _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState120
        | Tokens.OPEN ->
            _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
        | Tokens.NUM _v_2 ->
            _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState120
        | Tokens.HEX _v_3 ->
            _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState120
        | Tokens.DEC _v_4 ->
            _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState120
        | Tokens.BIN _v_5 ->
            _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState120
        | _ ->
            _eRR 120
    
    and _menhir_run_084 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
        let _v = _menhir_action_045 s in
        _menhir_goto_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_s_ _startpos_s_ _v _menhir_s _tok
    
    and _menhir_goto_identifier : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState436 ->
            _menhir_run_486 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState472 ->
            _menhir_run_473 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState439 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState476 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState468 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState465 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState459 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState453 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState444 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState430 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState389 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState348 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState318 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState230 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState215 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState083 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState085 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState167 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState168 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState161 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState158 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState152 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState140 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState134 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState108 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState120 ->
            _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState473 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState420 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState402 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState404 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState379 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState299 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState273 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState245 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState249 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState246 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState225 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState214 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState205 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState146 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState098 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState100 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState101 ->
            _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState099 ->
            _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | MenhirState096 ->
            _menhir_run_098 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_486 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_term) _menhir_state -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
        let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
        let _v = _menhir_action_103 _endpos_s_ _startpos_s_ s in
        _menhir_goto_qual_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_qual_identifier : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState436 ->
            _menhir_run_485 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState439 ->
            _menhir_run_476 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState085 ->
            _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState476 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState468 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState465 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState459 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState453 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState444 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState430 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState389 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState348 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState318 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState230 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState215 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState083 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState167 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState168 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState161 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState158 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState152 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState140 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState134 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState108 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState120 ->
            _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_485 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_term) _menhir_state -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let s = _v in
        let _v = _menhir_action_159 s in
        _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_476 : type  ttv_stack. ((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_term) _menhir_state -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_qual_identifier (_menhir_stack, _menhir_s, _v) in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState476
        | Tokens.STR _v_1 ->
            _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState476
        | Tokens.OPEN ->
            _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
        | Tokens.NUM _v_2 ->
            _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState476
        | Tokens.HEX _v_3 ->
            _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState476
        | Tokens.DEC _v_4 ->
            _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState476
        | Tokens.BIN _v_5 ->
            _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState476
        | _ ->
            _eRR 476
    
    and _menhir_run_005 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
        let _v = _menhir_action_157 _endpos_s_ _startpos_s_ s in
        _menhir_goto_spec_constant _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_s_ _v _menhir_s _tok
    
    and _menhir_goto_spec_constant : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState436 ->
            _menhir_run_484 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState476 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState468 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState465 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState459 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState453 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState444 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState430 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState389 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState348 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState318 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState230 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState215 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState083 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState167 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState168 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState161 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState158 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState152 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState140 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState134 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState108 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState120 ->
            _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState003 ->
            _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
        | MenhirState006 ->
            _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState053 ->
            _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState017 ->
            _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_484 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_term) _menhir_state -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let c = _v in
        let _v = _menhir_action_158 c in
        _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_123 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let c = _v in
        let _v = _menhir_action_158 c in
        _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_060 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_KEYWORD -> _ -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
        let (_endpos_v_, v) = (_endpos, _v) in
        let _v = _menhir_action_004 v in
        _menhir_goto_attribute_value _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_v_ _v _tok
    
    and _menhir_run_052 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let c = _v in
        let _v = _menhir_action_143 c in
        _menhir_goto_s_expr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_s_expr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_s_expr (_menhir_stack, _menhir_s, _v) in
        match (_tok : MenhirBasics.token) with
        | Tokens.UNDERSCORE ->
            _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.SYMBOL _v_0 ->
            _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState053
        | Tokens.STR _v_1 ->
            _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState053
        | Tokens.SET_OPTION ->
            _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.SET_LOGIC ->
            _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.SET_INFO ->
            _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.RESET_ASSERTIONS ->
            _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.RESET ->
            _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.PUSH ->
            _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.POP ->
            _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.PAR ->
            _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.OPEN ->
            _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.NUM _v_2 ->
            _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState053
        | Tokens.MATCH ->
            _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.LET ->
            _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.KEYWORD _v_3 ->
            _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState053
        | Tokens.HEX _v_4 ->
            _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState053
        | Tokens.GET_VALUE ->
            _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.GET_UNSAT_CORE ->
            _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.GET_UNSAT_ASSUMPTIONS ->
            _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.GET_PROOF ->
            _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.GET_OPTION ->
            _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.GET_MODEL ->
            _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.GET_INFO ->
            _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.GET_ASSIGNMENT ->
            _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.GET_ASSERTIONS ->
            _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.FORALL ->
            _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.EXIT ->
            _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.EXISTS ->
            _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.ECHO ->
            _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.DEFINE_SORT ->
            _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.DEFINE_FUN_REC ->
            _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.DEFINE_FUNS_REC ->
            _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.DEFINE_FUN ->
            _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.DECLARE_SORT ->
            _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.DECLARE_FUN ->
            _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.DECLARE_DATATYPES ->
            _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.DECLARE_DATATYPE ->
            _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.DECLARE_CONST ->
            _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.DEC _v_5 ->
            _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState053
        | Tokens.CHECK_SAT_ASSUMING ->
            _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.CHECK_SAT ->
            _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.BIN _v_6 ->
            _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState053
        | Tokens.ATTRIBUTE ->
            _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.ASSERT ->
            _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.AS ->
            _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
        | Tokens.CLOSE ->
            let _v_7 = _menhir_action_059 () in
            _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7
        | _ ->
            _eRR 53
    
    and _menhir_run_007 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_105 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_goto_reserved : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
        let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
        let _v = _menhir_action_145 _endpos_s_ _startpos_s_ s in
        _menhir_goto_s_expr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_008 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
        let _v = _menhir_action_144 _endpos_s_ _startpos_s_ s in
        _menhir_goto_s_expr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_009 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_142 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_010 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_141 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_011 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_140 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_012 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_139 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_013 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_138 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_014 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_137 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_015 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_136 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_016 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_112 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_017 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.UNDERSCORE ->
            _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.SYMBOL _v ->
            _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState017
        | Tokens.STR _v ->
            _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState017
        | Tokens.SET_OPTION ->
            _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.SET_LOGIC ->
            _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.SET_INFO ->
            _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.RESET_ASSERTIONS ->
            _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.RESET ->
            _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.PUSH ->
            _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.POP ->
            _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.PAR ->
            _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.OPEN ->
            _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.NUM _v ->
            _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState017
        | Tokens.MATCH ->
            _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.LET ->
            _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.KEYWORD _v ->
            _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState017
        | Tokens.HEX _v ->
            _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState017
        | Tokens.GET_VALUE ->
            _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.GET_UNSAT_CORE ->
            _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.GET_UNSAT_ASSUMPTIONS ->
            _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.GET_PROOF ->
            _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.GET_OPTION ->
            _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.GET_MODEL ->
            _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.GET_INFO ->
            _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.GET_ASSIGNMENT ->
            _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.GET_ASSERTIONS ->
            _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.FORALL ->
            _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.EXIT ->
            _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.EXISTS ->
            _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.ECHO ->
            _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.DEFINE_SORT ->
            _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.DEFINE_FUN_REC ->
            _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.DEFINE_FUNS_REC ->
            _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.DEFINE_FUN ->
            _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.DECLARE_SORT ->
            _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.DECLARE_FUN ->
            _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.DECLARE_DATATYPES ->
            _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.DECLARE_DATATYPE ->
            _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.DECLARE_CONST ->
            _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.DEC _v ->
            _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState017
        | Tokens.CHECK_SAT_ASSUMING ->
            _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.CHECK_SAT ->
            _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.BIN _v ->
            _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState017
        | Tokens.ATTRIBUTE ->
            _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.ASSERT ->
            _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.AS ->
            _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
        | Tokens.CLOSE ->
            let _v = _menhir_action_059 () in
            _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _eRR 17
    
    and _menhir_run_018 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
        let _v = _menhir_action_153 _endpos_s_ _startpos_s_ s in
        _menhir_goto_spec_constant _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_s_ _v _menhir_s _tok
    
    and _menhir_run_019 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_111 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_020 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_108 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_021 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
        let _v = _menhir_action_146 _endpos_s_ _startpos_s_ s in
        _menhir_goto_s_expr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_022 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
        let _v = _menhir_action_155 _endpos_s_ _startpos_s_ s in
        _menhir_goto_spec_constant _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_s_ _v _menhir_s _tok
    
    and _menhir_run_023 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_135 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_024 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_134 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_025 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_133 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_026 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_132 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_027 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_131 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_028 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_130 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_029 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_129 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_030 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_128 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_031 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_127 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_032 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_110 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_033 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_126 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_034 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_109 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_035 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_125 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_036 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_124 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_037 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_122 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_038 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_123 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_039 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_121 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_040 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_120 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_041 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_119 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_042 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_118 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_043 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_117 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_044 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_116 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_045 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
        let _v = _menhir_action_154 _endpos_s_ _startpos_s_ s in
        _menhir_goto_spec_constant _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_s_ _v _menhir_s _tok
    
    and _menhir_run_046 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_115 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_047 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_114 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_048 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
        let _v = _menhir_action_156 _endpos_s_ _startpos_s_ s in
        _menhir_goto_spec_constant _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_s_ _v _menhir_s _tok
    
    and _menhir_run_049 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_106 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_050 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_113 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_051 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
        let _v = _menhir_action_107 () in
        _menhir_goto_reserved _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_056 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_OPEN -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
        let (_endpos__3_, l) = (_endpos, _v) in
        let _v = _menhir_action_147 _endpos__3_ _startpos__1_ l in
        _menhir_goto_s_expr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_055 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_s_expr -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_s_expr (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_060 x xs in
        _menhir_goto_list_s_expr_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_goto_list_s_expr_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState006 ->
            _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState017 ->
            _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState053 ->
            _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_058 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_KEYWORD, ttv_result) _menhir_cell1_OPEN -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let MenhirCell1_OPEN (_menhir_stack, _, _startpos__1_) = _menhir_stack in
        let (_endpos__3_, l) = (_endpos, _v) in
        let _v = _menhir_action_006 _endpos__3_ _startpos__1_ l in
        _menhir_goto_attribute_value _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _tok
    
    and _menhir_run_085 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
        let _menhir_s = MenhirState085 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.UNDERSCORE ->
            _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | Tokens.MATCH ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell1_MATCH (_menhir_stack, _menhir_s, _startpos, _endpos) in
            let _menhir_s = MenhirState108 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.STR _v ->
                _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.OPEN ->
                _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
            | Tokens.NUM _v ->
                _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.HEX _v ->
                _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.DEC _v ->
                _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.BIN _v ->
                _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 108)
        | Tokens.LET ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell1_LET (_menhir_stack, _menhir_s, _startpos, _endpos) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
                let _menhir_s = MenhirState132 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                | _ ->
                    _eRR 132)
            | _ ->
                _eRR 131)
        | Tokens.FORALL ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell1_FORALL (_menhir_stack, _menhir_s, _startpos, _endpos) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
                let _menhir_s = MenhirState144 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                | _ ->
                    _eRR 144)
            | _ ->
                _eRR 143)
        | Tokens.EXISTS ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell1_EXISTS (_menhir_stack, _menhir_s, _startpos, _endpos) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
                let _menhir_s = MenhirState156 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                | _ ->
                    _eRR 156)
            | _ ->
                _eRR 155)
        | Tokens.ATTRIBUTE ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell1_ATTRIBUTE (_menhir_stack, _menhir_s, _startpos, _endpos) in
            let _menhir_s = MenhirState161 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.STR _v ->
                _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.OPEN ->
                _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
            | Tokens.NUM _v ->
                _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.HEX _v ->
                _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.DEC _v ->
                _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.BIN _v ->
                _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 161)
        | Tokens.AS ->
            _menhir_run_096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | _ ->
            _eRR 85
    
    and _menhir_run_086 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell1_UNDERSCORE (_menhir_stack, _menhir_s, _startpos, _endpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos, _endpos) in
            let _menhir_s = MenhirState087 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.NUM _v ->
                _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.HEX _v ->
                _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 87)
        | _ ->
            _eRR 86
    
    and _menhir_run_088 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        let s = _v in
        let _v = _menhir_action_048 s in
        _menhir_goto_index _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_index : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            let _menhir_stack = MenhirCell1_index (_menhir_stack, _menhir_s, _v) in
            _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState093
        | Tokens.NUM _v_1 ->
            let _menhir_stack = MenhirCell1_index (_menhir_stack, _menhir_s, _v) in
            _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState093
        | Tokens.HEX _v_2 ->
            let _menhir_stack = MenhirCell1_index (_menhir_stack, _menhir_s, _v) in
            _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState093
        | Tokens.CLOSE ->
            let x = _v in
            let _v = _menhir_action_078 x in
            _menhir_goto_nonempty_list_index_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 93
    
    and _menhir_run_089 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        let s = _v in
        let _v = _menhir_action_047 s in
        _menhir_goto_index _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_090 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        let s = _v in
        let _v = _menhir_action_049 s in
        _menhir_goto_index _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_nonempty_list_index_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState441 ->
            _menhir_run_442 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState093 ->
            _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState087 ->
            _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_442 : type  ttv_stack. ((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_UNDERSCORE _menhir_cell0_SYMBOL -> _ -> _ -> _ -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let MenhirCell0_SYMBOL (_menhir_stack, s, _, _) = _menhir_stack in
        let MenhirCell1_UNDERSCORE (_menhir_stack, _, _, _) = _menhir_stack in
        let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
        let (l, _endpos__5_) = (_v, _endpos) in
        let _v = _menhir_action_046 l s in
        _menhir_goto_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_094 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_index -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        let MenhirCell1_index (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_079 x xs in
        _menhir_goto_nonempty_list_index_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_091 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_UNDERSCORE _menhir_cell0_SYMBOL -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let MenhirCell0_SYMBOL (_menhir_stack, s, _, _) = _menhir_stack in
        let MenhirCell1_UNDERSCORE (_menhir_stack, _, _, _) = _menhir_stack in
        let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
        let (l, _endpos__5_) = (_v, _endpos) in
        let _v = _menhir_action_046 l s in
        _menhir_goto_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
    
    and _menhir_run_095 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
        let _menhir_s = MenhirState095 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.UNDERSCORE ->
            _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | Tokens.AS ->
            _menhir_run_096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | _ ->
            _eRR 95
    
    and _menhir_run_096 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell1_AS (_menhir_stack, _menhir_s, _startpos, _endpos) in
        let _menhir_s = MenhirState096 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | _ ->
            _eRR 96
    
    and _menhir_run_097 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
        let _menhir_s = MenhirState097 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.UNDERSCORE ->
            _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | _ ->
            _eRR 97
    
    and _menhir_run_133 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos, _endpos) in
            let _menhir_s = MenhirState134 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.STR _v ->
                _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.OPEN ->
                _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
            | Tokens.NUM _v ->
                _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.HEX _v ->
                _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.DEC _v ->
                _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.BIN _v ->
                _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 134)
        | _ ->
            _eRR 133
    
    and _menhir_run_145 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos, _endpos) in
            let _menhir_s = MenhirState146 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.OPEN ->
                _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
            | _ ->
                _eRR 146)
        | _ ->
            _eRR 145
    
    and _menhir_run_099 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
        let _menhir_s = MenhirState099 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.UNDERSCORE ->
            _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | _ ->
            _eRR 99
    
    and _menhir_run_167 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_qual_identifier (_menhir_stack, _menhir_s, _v) in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState167
        | Tokens.STR _v_1 ->
            _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState167
        | Tokens.OPEN ->
            _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState167
        | Tokens.NUM _v_2 ->
            _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState167
        | Tokens.HEX _v_3 ->
            _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState167
        | Tokens.DEC _v_4 ->
            _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState167
        | Tokens.BIN _v_5 ->
            _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState167
        | _ ->
            _eRR 167
    
    and _menhir_run_124 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let s = _v in
        let _v = _menhir_action_159 s in
        _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_473 : type  ttv_stack. (((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_AS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_term) _menhir_state -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState473
        | Tokens.OPEN ->
            _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState473
        | _ ->
            _eRR 473
    
    and _menhir_run_125 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
        let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
        let _v = _menhir_action_103 _endpos_s_ _startpos_s_ s in
        _menhir_goto_qual_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_103 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
        let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
        let _v = _menhir_action_149 _endpos_s_ _startpos_s_ s in
        _menhir_goto_sort _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_sort : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState473 ->
            _menhir_run_474 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState420 ->
            _menhir_run_421 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState404 ->
            _menhir_run_405 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState379 ->
            _menhir_run_380 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState299 ->
            _menhir_run_300 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState273 ->
            _menhir_run_274 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState249 ->
            _menhir_run_250 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState402 ->
            _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState246 ->
            _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState245 ->
            _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState225 ->
            _menhir_run_226 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState214 ->
            _menhir_run_215 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState205 ->
            _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState146 ->
            _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState098 ->
            _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState101 ->
            _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState100 ->
            _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_474 : type  ttv_stack. (((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_AS, _menhir_box_term) _menhir_cell1_identifier -> _ -> _ -> _ -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell1_identifier (_menhir_stack, _, s, _startpos_s_, _endpos_s_) = _menhir_stack in
            let MenhirCell1_AS (_menhir_stack, _, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__5_, ty) = (_endpos, _v) in
            let _v = _menhir_action_104 _endpos__5_ _endpos_s_ _startpos__1_ _startpos_s_ s ty in
            _menhir_goto_qual_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 474
    
    and _menhir_run_421 : type  ttv_stack. (ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DECLARE_CONST _menhir_cell0_SYMBOL -> _ -> _ -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_SYMBOL (_menhir_stack, s, _, _) = _menhir_stack in
            let MenhirCell0_DECLARE_CONST (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__5_, ty) = (_endpos, _v) in
            let _v = _menhir_action_010 _endpos__5_ _startpos__1_ s ty in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 421
    
    and _menhir_run_405 : type  ttv_stack. ((ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DECLARE_FUN _menhir_cell0_SYMBOL _menhir_cell0_OPEN, _menhir_box_input) _menhir_cell1_list_sort_ _menhir_cell0_CLOSE -> _ -> _ -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_list_sort_ (_menhir_stack, _, args) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell0_SYMBOL (_menhir_stack, s, _, _) = _menhir_stack in
            let MenhirCell0_DECLARE_FUN (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (ty, _endpos__8_) = (_v, _endpos) in
            let _v = _menhir_action_013 _endpos__8_ _startpos__1_ args s ty in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 405
    
    and _menhir_run_380 : type  ttv_stack. ((ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DEFINE_SORT _menhir_cell0_SYMBOL _menhir_cell0_OPEN, _menhir_box_input) _menhir_cell1_list_SYMBOL_ _menhir_cell0_CLOSE -> _ -> _ -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_list_SYMBOL_ (_menhir_stack, _, args) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell0_SYMBOL (_menhir_stack, s, _, _) = _menhir_stack in
            let MenhirCell0_DEFINE_SORT (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (ty, _endpos__8_) = (_v, _endpos) in
            let _v = _menhir_action_018 _endpos__8_ _startpos__1_ args s ty in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 380
    
    and _menhir_run_300 : type  ttv_stack. (ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DECLARE_CONST _menhir_cell0_SYMBOL -> _ -> _ -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_SYMBOL (_menhir_stack, s, _, _) = _menhir_stack in
            let MenhirCell0_DECLARE_CONST (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__5_, ty) = (_endpos, _v) in
            let _v = _menhir_action_010 _endpos__5_ _startpos__1_ s ty in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 300
    
    and _menhir_run_274 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_OPEN _menhir_cell0_SYMBOL -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_SYMBOL (_menhir_stack, s, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, ty) = (_endpos, _v) in
            let _v = _menhir_action_148 _endpos__4_ _startpos__1_ s ty in
            let _menhir_stack = MenhirCell1_selector_dec (_menhir_stack, _menhir_s, _v) in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                _menhir_run_272 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState276
            | Tokens.CLOSE ->
                let _v_0 = _menhir_action_061 () in
                _menhir_run_277 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0
            | _ ->
                _eRR 276)
        | _ ->
            _eRR 274
    
    and _menhir_run_272 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos, _endpos) in
            let _menhir_s = MenhirState273 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.OPEN ->
                _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
            | _ ->
                _eRR 273)
        | _ ->
            _eRR 272
    
    and _menhir_run_277 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_selector_dec -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_selector_dec (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_062 x xs in
        _menhir_goto_list_selector_dec_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_goto_list_selector_dec_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState271 ->
            _menhir_run_278 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState276 ->
            _menhir_run_277 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_278 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_OPEN _menhir_cell0_SYMBOL -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        let MenhirCell0_SYMBOL (_menhir_stack, s, _, _) = _menhir_stack in
        let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _) = _menhir_stack in
        let l = _v in
        let _v = _menhir_action_038 l s in
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            let _menhir_stack = MenhirCell1_constructor_dec (_menhir_stack, _menhir_s, _v) in
            _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState283
        | Tokens.CLOSE ->
            let x = _v in
            let _v = _menhir_action_070 x in
            _menhir_goto_nonempty_list_constructor_dec_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | _ ->
            _eRR 283
    
    and _menhir_run_270 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos_0, _endpos) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                _menhir_run_272 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState271
            | Tokens.CLOSE ->
                let _v_1 = _menhir_action_061 () in
                _menhir_run_278 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1
            | _ ->
                _eRR 271)
        | _ ->
            _eRR 270
    
    and _menhir_goto_nonempty_list_constructor_dec_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState263 ->
            _menhir_run_287 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState283 ->
            _menhir_run_284 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState269 ->
            _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_287 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_OPEN -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _) = _menhir_stack in
        let l = _v in
        let _v = _menhir_action_039 l in
        _menhir_goto_datatype_dec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_datatype_dec : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState416 ->
            _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState295 ->
            _menhir_run_296 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState411 ->
            _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState292 ->
            _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState262 ->
            _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_417 : type  ttv_stack. (ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DECLARE_DATATYPE _menhir_cell0_SYMBOL -> _ -> _ -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_SYMBOL (_menhir_stack, s, _, _) = _menhir_stack in
            let MenhirCell0_DECLARE_DATATYPE (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__5_, d) = (_endpos, _v) in
            let _v = _menhir_action_011 _endpos__5_ _startpos__1_ d s in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 417
    
    and _menhir_run_296 : type  ttv_stack. (ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DECLARE_DATATYPE _menhir_cell0_SYMBOL -> _ -> _ -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_SYMBOL (_menhir_stack, s, _, _) = _menhir_stack in
            let MenhirCell0_DECLARE_DATATYPE (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__5_, d) = (_endpos, _v) in
            let _v = _menhir_action_011 _endpos__5_ _startpos__1_ d s in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 296
    
    and _menhir_run_292 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            let _menhir_stack = MenhirCell1_datatype_dec (_menhir_stack, _menhir_s, _v) in
            _menhir_run_263 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState292
        | Tokens.CLOSE ->
            let x = _v in
            let _v = _menhir_action_072 x in
            _menhir_goto_nonempty_list_datatype_dec_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | _ ->
            _eRR 292
    
    and _menhir_run_263 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
        let _menhir_s = MenhirState263 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.PAR ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell1_PAR (_menhir_stack, _menhir_s, _startpos, _endpos) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
                let _menhir_s = MenhirState265 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | _ ->
                    _eRR 265)
            | _ ->
                _eRR 264)
        | Tokens.OPEN ->
            _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | _ ->
            _eRR 263
    
    and _menhir_run_266 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
        let _v = _menhir_action_041 _endpos_s_ _startpos_s_ s in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            let _menhir_stack = MenhirCell1_datatype_symbol (_menhir_stack, _menhir_s, _v) in
            _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState285
        | Tokens.CLOSE ->
            let x = _v in
            let _v = _menhir_action_074 x in
            _menhir_goto_nonempty_list_datatype_symbol_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | _ ->
            _eRR 285
    
    and _menhir_goto_nonempty_list_datatype_symbol_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState285 ->
            _menhir_run_286 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState265 ->
            _menhir_run_267 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_286 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_datatype_symbol -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_datatype_symbol (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_075 x xs in
        _menhir_goto_nonempty_list_datatype_symbol_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_run_267 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_PAR _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_nonempty_list_datatype_symbol_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
            let _menhir_s = MenhirState269 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
            | _ ->
                _eRR 269)
        | _ ->
            _eRR 268
    
    and _menhir_goto_nonempty_list_datatype_dec_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState411 ->
            _menhir_run_412 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState292 ->
            _menhir_run_293 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState262 ->
            _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_412 : type  ttv_stack. ((ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DECLARE_DATATYPES _menhir_cell0_OPEN, _menhir_box_input) _menhir_cell1_nonempty_list_sort_dec_ _menhir_cell0_CLOSE _menhir_cell0_OPEN -> _ -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_nonempty_list_sort_dec_ (_menhir_stack, _, l1) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _startpos__3_) = _menhir_stack in
            let MenhirCell0_DECLARE_DATATYPES (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__8_, _endpos__9_, l2) = (_endpos, _endpos_0, _v) in
            let _v = _menhir_action_012 _endpos__8_ _endpos__9_ _startpos__1_ _startpos__3_ l1 l2 in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 413
    
    and _menhir_run_293 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_datatype_dec -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_datatype_dec (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_073 x xs in
        _menhir_goto_nonempty_list_datatype_dec_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_run_289 : type  ttv_stack. ((ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DECLARE_DATATYPES _menhir_cell0_OPEN, _menhir_box_file) _menhir_cell1_nonempty_list_sort_dec_ _menhir_cell0_CLOSE _menhir_cell0_OPEN -> _ -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_nonempty_list_sort_dec_ (_menhir_stack, _, l1) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _startpos__3_) = _menhir_stack in
            let MenhirCell0_DECLARE_DATATYPES (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__8_, _endpos__9_, l2) = (_endpos, _endpos_0, _v) in
            let _v = _menhir_action_012 _endpos__8_ _endpos__9_ _startpos__1_ _startpos__3_ l1 l2 in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 290
    
    and _menhir_run_284 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_constructor_dec -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_constructor_dec (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_071 x xs in
        _menhir_goto_nonempty_list_constructor_dec_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_run_280 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_PAR _menhir_cell0_OPEN, ttv_result) _menhir_cell1_nonempty_list_datatype_symbol_ _menhir_cell0_CLOSE _menhir_cell0_OPEN -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_nonempty_list_datatype_symbol_ (_menhir_stack, _, vars) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_PAR (_menhir_stack, _, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _) = _menhir_stack in
            let l = _v in
            let _v = _menhir_action_040 l vars in
            _menhir_goto_datatype_dec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 281
    
    and _menhir_run_250 : type  ttv_stack. ((ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DECLARE_FUN _menhir_cell0_SYMBOL _menhir_cell0_OPEN, _menhir_box_file) _menhir_cell1_list_sort_ _menhir_cell0_CLOSE -> _ -> _ -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_list_sort_ (_menhir_stack, _, args) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell0_SYMBOL (_menhir_stack, s, _, _) = _menhir_stack in
            let MenhirCell0_DECLARE_FUN (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (ty, _endpos__8_) = (_v, _endpos) in
            let _v = _menhir_action_013 _endpos__8_ _startpos__1_ args s ty in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 250
    
    and _menhir_run_246 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_sort (_menhir_stack, _menhir_s, _v) in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState246
        | Tokens.OPEN ->
            _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
        | Tokens.CLOSE ->
            let _v_1 = _menhir_action_063 () in
            _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1
        | _ ->
            _eRR 246
    
    and _menhir_run_247 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_sort -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_sort (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_064 x xs in
        _menhir_goto_list_sort_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_goto_list_sort_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState402 ->
            _menhir_run_403 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState245 ->
            _menhir_run_248 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState246 ->
            _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_403 : type  ttv_stack. ((ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DECLARE_FUN _menhir_cell0_SYMBOL _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_input) _menhir_state -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_list_sort_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _menhir_s = MenhirState404 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | _ ->
            _eRR 404
    
    and _menhir_run_248 : type  ttv_stack. ((ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DECLARE_FUN _menhir_cell0_SYMBOL _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_file) _menhir_state -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_list_sort_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _menhir_s = MenhirState249 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | _ ->
            _eRR 249
    
    and _menhir_run_226 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN _menhir_cell0_SYMBOL _menhir_cell0_OPEN, ttv_result) _menhir_cell1_list_sorted_var_ _menhir_cell0_CLOSE -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_list_sorted_var_ (_menhir_stack, _, args) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell0_SYMBOL (_menhir_stack, s, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _) = _menhir_stack in
            let ret = _v in
            let _v = _menhir_action_043 args ret s in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                let _menhir_stack = MenhirCell1_function_dec (_menhir_stack, _menhir_s, _v) in
                _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
            | Tokens.CLOSE ->
                let x = _v in
                let _v = _menhir_action_076 x in
                _menhir_goto_nonempty_list_function_dec_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 234)
        | _ ->
            _eRR 226
    
    and _menhir_run_221 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos_0, _endpos) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
                let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos_1) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState223
                | Tokens.CLOSE ->
                    let _v_2 = _menhir_action_065 () in
                    _menhir_run_224 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState223
                | _ ->
                    _eRR 223)
            | _ ->
                _eRR 222)
        | _ ->
            _eRR 221
    
    and _menhir_run_224 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN _menhir_cell0_SYMBOL _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_list_sorted_var_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _menhir_s = MenhirState225 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | _ ->
            _eRR 225
    
    and _menhir_goto_nonempty_list_function_dec_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState386 ->
            _menhir_run_387 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState234 ->
            _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState220 ->
            _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_387 : type  ttv_stack. ((ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUNS_REC _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_input) _menhir_state -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_nonempty_list_function_dec_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
            let _menhir_s = MenhirState389 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.STR _v ->
                _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.OPEN ->
                _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
            | Tokens.NUM _v ->
                _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.HEX _v ->
                _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.DEC _v ->
                _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.BIN _v ->
                _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 389)
        | _ ->
            _eRR 388
    
    and _menhir_run_235 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_function_dec -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_function_dec (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_077 x xs in
        _menhir_goto_nonempty_list_function_dec_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_run_228 : type  ttv_stack. ((ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUNS_REC _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_file) _menhir_state -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_nonempty_list_function_dec_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
            let _menhir_s = MenhirState230 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SYMBOL _v ->
                _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.STR _v ->
                _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.OPEN ->
                _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
            | Tokens.NUM _v ->
                _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.HEX _v ->
                _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.DEC _v ->
                _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.BIN _v ->
                _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 230)
        | _ ->
            _eRR 229
    
    and _menhir_run_215 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SYMBOL _menhir_cell0_OPEN, ttv_result) _menhir_cell1_list_sorted_var_ _menhir_cell0_CLOSE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_sort (_menhir_stack, _menhir_s, _v) in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState215
        | Tokens.STR _v_1 ->
            _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState215
        | Tokens.OPEN ->
            _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState215
        | Tokens.NUM _v_2 ->
            _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState215
        | Tokens.HEX _v_3 ->
            _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState215
        | Tokens.DEC _v_4 ->
            _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState215
        | Tokens.BIN _v_5 ->
            _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState215
        | _ ->
            _eRR 215
    
    and _menhir_run_206 : type  ttv_stack. ((ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DEFINE_SORT _menhir_cell0_SYMBOL _menhir_cell0_OPEN, _menhir_box_file) _menhir_cell1_list_SYMBOL_ _menhir_cell0_CLOSE -> _ -> _ -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_list_SYMBOL_ (_menhir_stack, _, args) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell0_SYMBOL (_menhir_stack, s, _, _) = _menhir_stack in
            let MenhirCell0_DEFINE_SORT (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (ty, _endpos__8_) = (_v, _endpos) in
            let _v = _menhir_action_018 _endpos__8_ _startpos__1_ args s ty in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 206
    
    and _menhir_run_147 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_OPEN _menhir_cell0_SYMBOL -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_SYMBOL (_menhir_stack, s, _startpos_s_, _endpos_s_) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, ty) = (_endpos, _v) in
            let _v = _menhir_action_152 _endpos__4_ _endpos_s_ _startpos__1_ _startpos_s_ s ty in
            _menhir_goto_sorted_var _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 147
    
    and _menhir_goto_sorted_var : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState223 ->
            _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState211 ->
            _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState210 ->
            _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState463 ->
            _menhir_run_149 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState457 ->
            _menhir_run_149 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState156 ->
            _menhir_run_149 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState149 ->
            _menhir_run_149 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | MenhirState144 ->
            _menhir_run_149 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_211 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_sorted_var (_menhir_stack, _menhir_s, _v) in
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState211
        | Tokens.CLOSE ->
            let _v_0 = _menhir_action_065 () in
            _menhir_run_212 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0
        | _ ->
            _eRR 211
    
    and _menhir_run_212 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_sorted_var -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_sorted_var (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_066 x xs in
        _menhir_goto_list_sorted_var_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_goto_list_sorted_var_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState223 ->
            _menhir_run_224 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState210 ->
            _menhir_run_213 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState211 ->
            _menhir_run_212 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_213 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SYMBOL _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_list_sorted_var_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _menhir_s = MenhirState214 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | _ ->
            _eRR 214
    
    and _menhir_run_149 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            let _menhir_stack = MenhirCell1_sorted_var (_menhir_stack, _menhir_s, _v) in
            _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState149
        | Tokens.CLOSE ->
            let x = _v in
            let _v = _menhir_action_088 x in
            _menhir_goto_nonempty_list_sorted_var_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | _ ->
            _eRR 149
    
    and _menhir_goto_nonempty_list_sorted_var_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState463 ->
            _menhir_run_464 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState457 ->
            _menhir_run_458 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState156 ->
            _menhir_run_157 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState144 ->
            _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState149 ->
            _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_464 : type  ttv_stack. (((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_EXISTS _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_term) _menhir_state -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_nonempty_list_sorted_var_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _menhir_s = MenhirState465 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.STR _v ->
            _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | Tokens.NUM _v ->
            _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.HEX _v ->
            _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.DEC _v ->
            _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.BIN _v ->
            _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | _ ->
            _eRR 465
    
    and _menhir_run_458 : type  ttv_stack. (((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_FORALL _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_term) _menhir_state -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_nonempty_list_sorted_var_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _menhir_s = MenhirState459 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.STR _v ->
            _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | Tokens.NUM _v ->
            _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.HEX _v ->
            _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.DEC _v ->
            _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.BIN _v ->
            _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | _ ->
            _eRR 459
    
    and _menhir_run_157 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_EXISTS _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_nonempty_list_sorted_var_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _menhir_s = MenhirState158 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.STR _v ->
            _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | Tokens.NUM _v ->
            _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.HEX _v ->
            _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.DEC _v ->
            _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.BIN _v ->
            _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | _ ->
            _eRR 158
    
    and _menhir_run_151 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_FORALL _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_nonempty_list_sorted_var_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _menhir_s = MenhirState152 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.STR _v ->
            _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | Tokens.NUM _v ->
            _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.HEX _v ->
            _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.DEC _v ->
            _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.BIN _v ->
            _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | _ ->
            _eRR 152
    
    and _menhir_run_150 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_sorted_var -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_sorted_var (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_089 x xs in
        _menhir_goto_nonempty_list_sorted_var_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_run_106 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_AS, ttv_result) _menhir_cell1_identifier -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell1_identifier (_menhir_stack, _, s, _startpos_s_, _endpos_s_) = _menhir_stack in
            let MenhirCell1_AS (_menhir_stack, _, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__5_, ty) = (_endpos, _v) in
            let _v = _menhir_action_104 _endpos__5_ _endpos_s_ _startpos__1_ _startpos_s_ s ty in
            _menhir_goto_qual_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 106
    
    and _menhir_run_101 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            let _menhir_stack = MenhirCell1_sort (_menhir_stack, _menhir_s, _v) in
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState101
        | Tokens.OPEN ->
            let _menhir_stack = MenhirCell1_sort (_menhir_stack, _menhir_s, _v) in
            _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState101
        | Tokens.CLOSE ->
            let x = _v in
            let _v = _menhir_action_084 x in
            _menhir_goto_nonempty_list_sort_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | _ ->
            _eRR 101
    
    and _menhir_goto_nonempty_list_sort_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState100 ->
            _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState101 ->
            _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_104 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_identifier -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let MenhirCell1_identifier (_menhir_stack, _, f, _startpos_f_, _endpos_f_) = _menhir_stack in
        let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
        let (_endpos__4_, args) = (_endpos, _v) in
        let _v = _menhir_action_150 _endpos__4_ _endpos_f_ _startpos__1_ _startpos_f_ args f in
        _menhir_goto_sort _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_102 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_sort -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_sort (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_085 x xs in
        _menhir_goto_nonempty_list_sort_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_run_100 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState100
        | Tokens.OPEN ->
            _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
        | _ ->
            _eRR 100
    
    and _menhir_run_098 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_AS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState098
        | Tokens.OPEN ->
            _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState098
        | _ ->
            _eRR 98
    
    and _menhir_run_115 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_pattern_symbol as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            let _menhir_stack = MenhirCell1_pattern_symbol (_menhir_stack, _menhir_s, _v) in
            _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState115
        | Tokens.CLOSE ->
            let x = _v in
            let _v = _menhir_action_082 x in
            _menhir_goto_nonempty_list_pattern_symbol_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | _ ->
            _eRR 115
    
    and _menhir_goto_nonempty_list_pattern_symbol_ : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_pattern_symbol as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState114 ->
            _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState115 ->
            _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_117 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_pattern_symbol -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let MenhirCell1_pattern_symbol (_menhir_stack, _, f) = _menhir_stack in
        let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
        let (_endpos__4_, args) = (_endpos, _v) in
        let _v = _menhir_action_098 _endpos__4_ _startpos__1_ args f in
        _menhir_goto_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_116 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_pattern_symbol, ttv_result) _menhir_cell1_pattern_symbol -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_pattern_symbol (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_083 x xs in
        _menhir_goto_nonempty_list_pattern_symbol_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_run_114 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_pattern_symbol (_menhir_stack, _menhir_s, _v) in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState114
        | _ ->
            _eRR 114
    
    and _menhir_run_431 : type  ttv_stack. (ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_ASSERT -> _ -> _ -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_ASSERT (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, t) = (_endpos, _v) in
            let _v = _menhir_action_007 _endpos__4_ _startpos__1_ t in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 431
    
    and _menhir_run_319 : type  ttv_stack. (ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_ASSERT -> _ -> _ -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_ASSERT (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, t) = (_endpos, _v) in
            let _v = _menhir_action_007 _endpos__4_ _startpos__1_ t in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 319
    
    and _menhir_run_216 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SYMBOL _menhir_cell0_OPEN, ttv_result) _menhir_cell1_list_sorted_var_ _menhir_cell0_CLOSE, ttv_result) _menhir_cell1_sort -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        let MenhirCell1_sort (_menhir_stack, _, ret) = _menhir_stack in
        let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
        let MenhirCell1_list_sorted_var_ (_menhir_stack, _, args) = _menhir_stack in
        let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
        let MenhirCell1_SYMBOL (_menhir_stack, _menhir_s, s, _, _) = _menhir_stack in
        let body = _v in
        let _v = _menhir_action_044 args body ret s in
        _menhir_goto_function_def _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_function_def : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState393 ->
            _menhir_run_394 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState382 ->
            _menhir_run_383 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState236 ->
            _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState208 ->
            _menhir_run_217 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_394 : type  ttv_stack. (ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUN -> _ -> _ -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_DEFINE_FUN (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, f) = (_endpos, _v) in
            let _v = _menhir_action_015 _endpos__4_ _startpos__1_ f in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 394
    
    and _menhir_run_383 : type  ttv_stack. (ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUN_REC -> _ -> _ -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_DEFINE_FUN_REC (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, f) = (_endpos, _v) in
            let _v = _menhir_action_016 _endpos__4_ _startpos__1_ f in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 383
    
    and _menhir_run_237 : type  ttv_stack. (ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUN -> _ -> _ -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_DEFINE_FUN (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, f) = (_endpos, _v) in
            let _v = _menhir_action_015 _endpos__4_ _startpos__1_ f in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 237
    
    and _menhir_run_217 : type  ttv_stack. (ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUN_REC -> _ -> _ -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_DEFINE_FUN_REC (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, f) = (_endpos, _v) in
            let _v = _menhir_action_016 _endpos__4_ _startpos__1_ f in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 217
    
    and _menhir_run_168 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            let _menhir_stack = MenhirCell1_term (_menhir_stack, _menhir_s, _v) in
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState168
        | Tokens.STR _v_1 ->
            let _menhir_stack = MenhirCell1_term (_menhir_stack, _menhir_s, _v) in
            _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState168
        | Tokens.OPEN ->
            let _menhir_stack = MenhirCell1_term (_menhir_stack, _menhir_s, _v) in
            _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState168
        | Tokens.NUM _v_2 ->
            let _menhir_stack = MenhirCell1_term (_menhir_stack, _menhir_s, _v) in
            _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState168
        | Tokens.HEX _v_3 ->
            let _menhir_stack = MenhirCell1_term (_menhir_stack, _menhir_s, _v) in
            _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState168
        | Tokens.DEC _v_4 ->
            let _menhir_stack = MenhirCell1_term (_menhir_stack, _menhir_s, _v) in
            _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState168
        | Tokens.BIN _v_5 ->
            let _menhir_stack = MenhirCell1_term (_menhir_stack, _menhir_s, _v) in
            _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState168
        | Tokens.CLOSE ->
            let x = _v in
            let _v = _menhir_action_090 x in
            _menhir_goto_nonempty_list_term_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 168
    
    and _menhir_goto_nonempty_list_term_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState476 ->
            _menhir_run_477 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState389 ->
            _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState348 ->
            _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState230 ->
            _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState083 ->
            _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState167 ->
            _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState168 ->
            _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_477 : type  ttv_stack. ((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_qual_identifier -> _ -> _ -> _ -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let MenhirCell1_qual_identifier (_menhir_stack, _, s) = _menhir_stack in
        let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
        let (_endpos__4_, args) = (_endpos, _v) in
        let _v = _menhir_action_160 _endpos__4_ _startpos__1_ args s in
        _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_390 : type  ttv_stack. ((ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUNS_REC _menhir_cell0_OPEN, _menhir_box_input) _menhir_cell1_nonempty_list_function_dec_ _menhir_cell0_CLOSE _menhir_cell0_OPEN -> _ -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_nonempty_list_function_dec_ (_menhir_stack, _, l1) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _startpos__3_) = _menhir_stack in
            let MenhirCell0_DEFINE_FUNS_REC (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__8_, _endpos__9_, l2) = (_endpos, _endpos_0, _v) in
            let _v = _menhir_action_017 _endpos__8_ _endpos__9_ _startpos__1_ _startpos__3_ l1 l2 in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 391
    
    and _menhir_run_349 : type  ttv_stack. (ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_GET_VALUE _menhir_cell0_OPEN -> _ -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell0_GET_VALUE (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (l, _endpos__6_) = (_v, _endpos_0) in
            let _v = _menhir_action_029 _endpos__6_ _startpos__1_ l in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 350
    
    and _menhir_run_231 : type  ttv_stack. ((ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DEFINE_FUNS_REC _menhir_cell0_OPEN, _menhir_box_file) _menhir_cell1_nonempty_list_function_dec_ _menhir_cell0_CLOSE _menhir_cell0_OPEN -> _ -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_nonempty_list_function_dec_ (_menhir_stack, _, l1) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _startpos__3_) = _menhir_stack in
            let MenhirCell0_DEFINE_FUNS_REC (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__8_, _endpos__9_, l2) = (_endpos, _endpos_0, _v) in
            let _v = _menhir_action_017 _endpos__8_ _endpos__9_ _startpos__1_ _startpos__3_ l1 l2 in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 232
    
    and _menhir_run_172 : type  ttv_stack. (ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_GET_VALUE _menhir_cell0_OPEN -> _ -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell0_GET_VALUE (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (l, _endpos__6_) = (_v, _endpos_0) in
            let _v = _menhir_action_029 _endpos__6_ _startpos__1_ l in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 173
    
    and _menhir_run_170 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_qual_identifier -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let MenhirCell1_qual_identifier (_menhir_stack, _, s) = _menhir_stack in
        let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
        let (_endpos__4_, args) = (_endpos, _v) in
        let _v = _menhir_action_160 _endpos__4_ _startpos__1_ args s in
        _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_169 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_term -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        let MenhirCell1_term (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_091 x xs in
        _menhir_goto_nonempty_list_term_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_162 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_ATTRIBUTE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_term (_menhir_stack, _menhir_s, _v) in
        match (_tok : MenhirBasics.token) with
        | Tokens.KEYWORD _v_0 ->
            _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState162
        | _ ->
            _eRR 162
    
    and _menhir_run_159 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_EXISTS _menhir_cell0_OPEN, ttv_result) _menhir_cell1_nonempty_list_sorted_var_ _menhir_cell0_CLOSE -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_nonempty_list_sorted_var_ (_menhir_stack, _, l) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_EXISTS (_menhir_stack, _, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__7_, t) = (_endpos, _v) in
            let _v = _menhir_action_163 _endpos__7_ _startpos__1_ l t in
            _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 159
    
    and _menhir_run_153 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_FORALL _menhir_cell0_OPEN, ttv_result) _menhir_cell1_nonempty_list_sorted_var_ _menhir_cell0_CLOSE -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_nonempty_list_sorted_var_ (_menhir_stack, _, l) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_FORALL (_menhir_stack, _, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__7_, t) = (_endpos, _v) in
            let _v = _menhir_action_162 _endpos__7_ _startpos__1_ l t in
            _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 153
    
    and _menhir_run_141 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_LET _menhir_cell0_OPEN, ttv_result) _menhir_cell1_nonempty_list_var_binding_ _menhir_cell0_CLOSE -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_CLOSE (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_nonempty_list_var_binding_ (_menhir_stack, _, l) = _menhir_stack in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_LET (_menhir_stack, _, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__7_, t) = (_endpos, _v) in
            let _v = _menhir_action_161 _endpos__7_ _startpos__1_ l t in
            _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 141
    
    and _menhir_run_135 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_OPEN _menhir_cell0_SYMBOL -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_SYMBOL (_menhir_stack, s, _startpos_s_, _endpos_s_) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, t) = (_endpos, _v) in
            let _v = _menhir_action_166 _endpos__4_ _endpos_s_ _startpos__1_ _startpos_s_ s t in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                let _menhir_stack = MenhirCell1_var_binding (_menhir_stack, _menhir_s, _v) in
                _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState137
            | Tokens.CLOSE ->
                let x = _v in
                let _v = _menhir_action_092 x in
                _menhir_goto_nonempty_list_var_binding_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 137)
        | _ ->
            _eRR 135
    
    and _menhir_goto_nonempty_list_var_binding_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState451 ->
            _menhir_run_452 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState132 ->
            _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState137 ->
            _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_452 : type  ttv_stack. (((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_LET _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_term) _menhir_state -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_nonempty_list_var_binding_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _menhir_s = MenhirState453 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.STR _v ->
            _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | Tokens.NUM _v ->
            _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.HEX _v ->
            _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.DEC _v ->
            _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.BIN _v ->
            _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | _ ->
            _eRR 453
    
    and _menhir_run_139 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_LET _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_nonempty_list_var_binding_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _menhir_s = MenhirState140 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.STR _v ->
            _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | Tokens.NUM _v ->
            _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.HEX _v ->
            _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.DEC _v ->
            _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.BIN _v ->
            _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | _ ->
            _eRR 140
    
    and _menhir_run_138 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_var_binding -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_var_binding (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_093 x xs in
        _menhir_goto_nonempty_list_var_binding_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_run_121 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_pattern -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell1_pattern (_menhir_stack, _, p) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _) = _menhir_stack in
            let t = _v in
            let _v = _menhir_action_067 p t in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                let _menhir_stack = MenhirCell1_match_case (_menhir_stack, _menhir_s, _v) in
                _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
            | Tokens.CLOSE ->
                let x = _v in
                let _v = _menhir_action_080 x in
                _menhir_goto_nonempty_list_match_case_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | _ ->
                _eRR 129)
        | _ ->
            _eRR 121
    
    and _menhir_goto_nonempty_list_match_case_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState446 ->
            _menhir_run_447 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState129 ->
            _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | MenhirState110 ->
            _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_447 : type  ttv_stack. (((ttv_stack, _menhir_box_term) _menhir_cell1_OPEN, _menhir_box_term) _menhir_cell1_MATCH, _menhir_box_term) _menhir_cell1_term _menhir_cell0_OPEN -> _ -> _ -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_term (_menhir_stack, _, t) = _menhir_stack in
            let MenhirCell1_MATCH (_menhir_stack, _, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (l, _endpos__7_) = (_v, _endpos_0) in
            let _v = _menhir_action_164 _endpos__7_ _startpos__1_ l t in
            _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 448
    
    and _menhir_run_130 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_match_case -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_match_case (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_081 x xs in
        _menhir_goto_nonempty_list_match_case_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_run_126 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_MATCH, ttv_result) _menhir_cell1_term _menhir_cell0_OPEN -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_OPEN (_menhir_stack, _) = _menhir_stack in
            let MenhirCell1_term (_menhir_stack, _, t) = _menhir_stack in
            let MenhirCell1_MATCH (_menhir_stack, _, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (l, _endpos__7_) = (_v, _endpos_0) in
            let _v = _menhir_action_164 _endpos__7_ _startpos__1_ l t in
            _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 127
    
    and _menhir_run_109 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_MATCH as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let _menhir_stack = MenhirCell1_term (_menhir_stack, _menhir_s, _v) in
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
            let _menhir_s = MenhirState110 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
            | _ ->
                _eRR 110)
        | _ ->
            _eRR 109
    
    and _menhir_run_166 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_attribute -> _ -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        let MenhirCell1_attribute (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_069 x xs in
        _menhir_goto_nonempty_list_attribute_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_163 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_ATTRIBUTE, ttv_result) _menhir_cell1_term -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _tok = _menhir_lexer _menhir_lexbuf in
        let MenhirCell1_term (_menhir_stack, _, f) = _menhir_stack in
        let MenhirCell1_ATTRIBUTE (_menhir_stack, _, _, _) = _menhir_stack in
        let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
        let (_endpos__5_, args) = (_endpos, _v) in
        let _v = _menhir_action_165 _endpos__5_ _startpos__1_ args f in
        _menhir_goto_term _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_run_065 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        let a = _v in
        let _v = _menhir_action_037 a in
        _menhir_goto_command_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_command_option : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState334 ->
            _menhir_run_335 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState328 ->
            _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState069 ->
            _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState002 ->
            _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_335 : type  ttv_stack. (ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_SET_INFO -> _ -> _ -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_SET_INFO (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, c) = (_endpos, _v) in
            let _v = _menhir_action_034 _endpos__4_ _startpos__1_ c in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 335
    
    and _menhir_run_329 : type  ttv_stack. (ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_SET_OPTION -> _ -> _ -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_SET_OPTION (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, c) = (_endpos, _v) in
            let _v = _menhir_action_036 _endpos__4_ _startpos__1_ c in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 329
    
    and _menhir_run_070 : type  ttv_stack. (ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_SET_INFO -> _ -> _ -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_SET_INFO (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, c) = (_endpos, _v) in
            let _v = _menhir_action_034 _endpos__4_ _startpos__1_ c in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 70
    
    and _menhir_run_063 : type  ttv_stack. (ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_SET_OPTION -> _ -> _ -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_SET_OPTION (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, c) = (_endpos, _v) in
            let _v = _menhir_action_036 _endpos__4_ _startpos__1_ c in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 63
    
    and _menhir_run_187 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN _menhir_cell0_GET_INFO as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        let s = _v in
        let _v = _menhir_action_050 s in
        _menhir_goto_info_flag _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
    
    and _menhir_goto_info_flag : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN _menhir_cell0_GET_INFO as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
        match _menhir_s with
        | MenhirState363 ->
            _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | MenhirState186 ->
            _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_364 : type  ttv_stack. (ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_GET_INFO -> _ -> _ -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let MenhirCell0_GET_INFO (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, i) = (_endpos, _v) in
            let _v = _menhir_action_023 _endpos__4_ _startpos__1_ i in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 364
    
    and _menhir_run_188 : type  ttv_stack. (ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_GET_INFO -> _ -> _ -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
        match (_tok : MenhirBasics.token) with
        | Tokens.CLOSE ->
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            let MenhirCell0_GET_INFO (_menhir_stack, _, _) = _menhir_stack in
            let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
            let (_endpos__4_, i) = (_endpos, _v) in
            let _v = _menhir_action_023 _endpos__4_ _startpos__1_ i in
            _menhir_goto_command _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
        | _ ->
            _eRR 188
    
    and _menhir_run_202 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell1_SYMBOL (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v_0 ->
            _menhir_run_202 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState202
        | Tokens.CLOSE ->
            let _v_1 = _menhir_action_053 () in
            _menhir_run_203 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1
        | _ ->
            _eRR 202
    
    and _menhir_run_203 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SYMBOL -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_SYMBOL (_menhir_stack, _menhir_s, x, _, _) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_054 x xs in
        _menhir_goto_list_SYMBOL_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    and _menhir_goto_list_SYMBOL_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState377 ->
            _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState201 ->
            _menhir_run_204 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState202 ->
            _menhir_run_203 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_378 : type  ttv_stack. ((ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DEFINE_SORT _menhir_cell0_SYMBOL _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_input) _menhir_state -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_list_SYMBOL_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _menhir_s = MenhirState379 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | _ ->
            _eRR 379
    
    and _menhir_run_204 : type  ttv_stack. ((ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DEFINE_SORT _menhir_cell0_SYMBOL _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_file) _menhir_state -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_list_SYMBOL_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _menhir_s = MenhirState205 in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | Tokens.OPEN ->
            _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
        | _ ->
            _eRR 205
    
    and _menhir_run_209 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell1_SYMBOL (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
            let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos_0) in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState210
            | Tokens.CLOSE ->
                let _v_1 = _menhir_action_065 () in
                _menhir_run_213 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState210
            | _ ->
                _eRR 210)
        | _ ->
            _eRR 209
    
    and _menhir_run_254 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.NUM _v_1 ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    let (s, n) = (_v, _v_1) in
                    let _v = _menhir_action_151 n s in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.OPEN ->
                        let _menhir_stack = MenhirCell1_sort_dec (_menhir_stack, _menhir_s, _v) in
                        _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState258
                    | Tokens.CLOSE ->
                        let x = _v in
                        let _v = _menhir_action_086 x in
                        _menhir_goto_nonempty_list_sort_dec_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                    | _ ->
                        _eRR 258)
                | _ ->
                    _eRR 256)
            | _ ->
                _eRR 255)
        | _ ->
            _eRR 254
    
    and _menhir_goto_nonempty_list_sort_dec_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        match _menhir_s with
        | MenhirState408 ->
            _menhir_run_409 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState253 ->
            _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
        | MenhirState258 ->
            _menhir_run_259 _menhir_stack _menhir_lexbuf _menhir_lexer _v
        | _ ->
            _menhir_fail ()
    
    and _menhir_run_409 : type  ttv_stack. ((ttv_stack, _menhir_box_input) _menhir_cell1_OPEN _menhir_cell0_DECLARE_DATATYPES _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_input) _menhir_state -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_nonempty_list_sort_dec_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
            let _menhir_s = MenhirState411 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                _menhir_run_263 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
            | _ ->
                _eRR 411)
        | _ ->
            _eRR 410
    
    and _menhir_run_260 : type  ttv_stack. ((ttv_stack, _menhir_box_file) _menhir_cell1_OPEN _menhir_cell0_DECLARE_DATATYPES _menhir_cell0_OPEN as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_file) _menhir_state -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
        let _menhir_stack = MenhirCell1_nonempty_list_sort_dec_ (_menhir_stack, _menhir_s, _v) in
        let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
        let _menhir_stack = MenhirCell0_CLOSE (_menhir_stack, _endpos) in
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
            let _menhir_s = MenhirState262 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.OPEN ->
                _menhir_run_263 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
            | _ ->
                _eRR 262)
        | _ ->
            _eRR 261
    
    and _menhir_run_259 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_sort_dec -> _ -> _ -> _ -> ttv_result =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
        let MenhirCell1_sort_dec (_menhir_stack, _menhir_s, x) = _menhir_stack in
        let xs = _v in
        let _v = _menhir_action_087 x xs in
        _menhir_goto_nonempty_list_sort_dec_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
    
    let _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_file =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
        | Tokens.EOF ->
            let _v = _menhir_action_055 () in
            _menhir_run_321 _menhir_stack _v
        | _ ->
            _eRR 0
    
    let _menhir_run_326 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_input =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.OPEN ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.SET_OPTION ->
                let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState326, _startpos) in
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_SET_OPTION (_menhir_stack, _startpos, _endpos) in
                let _menhir_s = MenhirState328 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.KEYWORD _v ->
                    _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | _ ->
                    _eRR 328)
            | Tokens.SET_LOGIC ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.CLOSE ->
                        let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
                        let _v =
                          let (_startpos__1_, s, _endpos__4_) = (_startpos, _v, _endpos_4) in
                          _menhir_action_035 _endpos__4_ _startpos__1_ s
                        in
                        _menhir_run_435 _menhir_stack _v
                    | _ ->
                        _eRR 332)
                | _ ->
                    _eRR 331)
            | Tokens.SET_INFO ->
                let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState326, _startpos) in
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_SET_INFO (_menhir_stack, _startpos, _endpos) in
                let _menhir_s = MenhirState334 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.KEYWORD _v ->
                    _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | _ ->
                    _eRR 334)
            | Tokens.RESET_ASSERTIONS ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _v =
                      let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_7) in
                      _menhir_action_033 _endpos__3_ _startpos__1_
                    in
                    _menhir_run_435 _menhir_stack _v
                | _ ->
                    _eRR 337)
            | Tokens.RESET ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _v =
                      let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_9) in
                      _menhir_action_032 _endpos__3_ _startpos__1_
                    in
                    _menhir_run_435 _menhir_stack _v
                | _ ->
                    _eRR 339)
            | Tokens.PUSH ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.NUM _v ->
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.CLOSE ->
                        let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
                        let _v =
                          let (_startpos__1_, _endpos__4_, n) = (_startpos, _endpos_13, _v) in
                          _menhir_action_031 _endpos__4_ _startpos__1_ n
                        in
                        _menhir_run_435 _menhir_stack _v
                    | _ ->
                        _eRR 342)
                | _ ->
                    _eRR 341)
            | Tokens.POP ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.NUM _v ->
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.CLOSE ->
                        let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
                        let _v =
                          let (_startpos__1_, _endpos__4_, n) = (_startpos, _endpos_17, _v) in
                          _menhir_action_030 _endpos__4_ _startpos__1_ n
                        in
                        _menhir_run_435 _menhir_stack _v
                    | _ ->
                        _eRR 345)
                | _ ->
                    _eRR 344)
            | Tokens.GET_VALUE ->
                let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState326, _startpos) in
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_GET_VALUE (_menhir_stack, _startpos, _endpos) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                    let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
                    let _menhir_s = MenhirState348 in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.SYMBOL _v ->
                        _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                    | Tokens.STR _v ->
                        _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                    | Tokens.OPEN ->
                        _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                    | Tokens.NUM _v ->
                        _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                    | Tokens.HEX _v ->
                        _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                    | Tokens.DEC _v ->
                        _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                    | Tokens.BIN _v ->
                        _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                    | _ ->
                        _eRR 348)
                | _ ->
                    _eRR 347)
            | Tokens.GET_UNSAT_CORE ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _v =
                      let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_21) in
                      _menhir_action_028 _endpos__3_ _startpos__1_
                    in
                    _menhir_run_435 _menhir_stack _v
                | _ ->
                    _eRR 352)
            | Tokens.GET_UNSAT_ASSUMPTIONS ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_23 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _v =
                      let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_23) in
                      _menhir_action_027 _endpos__3_ _startpos__1_
                    in
                    _menhir_run_435 _menhir_stack _v
                | _ ->
                    _eRR 354)
            | Tokens.GET_PROOF ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_25 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _v =
                      let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_25) in
                      _menhir_action_026 _endpos__3_ _startpos__1_
                    in
                    _menhir_run_435 _menhir_stack _v
                | _ ->
                    _eRR 356)
            | Tokens.GET_OPTION ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.KEYWORD _v ->
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.CLOSE ->
                        let _endpos_29 = _menhir_lexbuf.Lexing.lex_curr_p in
                        let _v =
                          let (_startpos__1_, _endpos__4_, k) = (_startpos, _endpos_29, _v) in
                          _menhir_action_025 _endpos__4_ _startpos__1_ k
                        in
                        _menhir_run_435 _menhir_stack _v
                    | _ ->
                        _eRR 359)
                | _ ->
                    _eRR 358)
            | Tokens.GET_MODEL ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_31 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _v =
                      let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_31) in
                      _menhir_action_024 _endpos__3_ _startpos__1_
                    in
                    _menhir_run_435 _menhir_stack _v
                | _ ->
                    _eRR 361)
            | Tokens.GET_INFO ->
                let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState326, _startpos) in
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_GET_INFO (_menhir_stack, _startpos, _endpos) in
                let _menhir_s = MenhirState363 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.KEYWORD _v ->
                    _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | _ ->
                    _eRR 363)
            | Tokens.GET_ASSIGNMENT ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_34 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _v =
                      let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_34) in
                      _menhir_action_022 _endpos__3_ _startpos__1_
                    in
                    _menhir_run_435 _menhir_stack _v
                | _ ->
                    _eRR 366)
            | Tokens.GET_ASSERTIONS ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_36 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _v =
                      let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_36) in
                      _menhir_action_021 _endpos__3_ _startpos__1_
                    in
                    _menhir_run_435 _menhir_stack _v
                | _ ->
                    _eRR 368)
            | Tokens.EXIT ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_38 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _v =
                      let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_38) in
                      _menhir_action_020 _endpos__3_ _startpos__1_
                    in
                    _menhir_run_435 _menhir_stack _v
                | _ ->
                    _eRR 370)
            | Tokens.ECHO ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.STR _v ->
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.CLOSE ->
                        let _endpos_42 = _menhir_lexbuf.Lexing.lex_curr_p in
                        let _v =
                          let (_startpos__1_, s, _endpos__4_) = (_startpos, _v, _endpos_42) in
                          _menhir_action_019 _endpos__4_ _startpos__1_ s
                        in
                        _menhir_run_435 _menhir_stack _v
                    | _ ->
                        _eRR 373)
                | _ ->
                    _eRR 372)
            | Tokens.DEFINE_SORT ->
                let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState326, _startpos) in
                let _startpos_43 = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_DEFINE_SORT (_menhir_stack, _startpos_43, _endpos) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    let _startpos_44 = _menhir_lexbuf.Lexing.lex_start_p in
                    let _endpos_45 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos_44, _endpos_45) in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.OPEN ->
                        let _startpos_46 = _menhir_lexbuf.Lexing.lex_start_p in
                        let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos_46) in
                        let _tok = _menhir_lexer _menhir_lexbuf in
                        (match (_tok : MenhirBasics.token) with
                        | Tokens.SYMBOL _v_47 ->
                            _menhir_run_202 _menhir_stack _menhir_lexbuf _menhir_lexer _v_47 MenhirState377
                        | Tokens.CLOSE ->
                            let _v_48 = _menhir_action_053 () in
                            _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _v_48 MenhirState377
                        | _ ->
                            _eRR 377)
                    | _ ->
                        _eRR 376)
                | _ ->
                    _eRR 375)
            | Tokens.DEFINE_FUN_REC ->
                let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState326, _startpos) in
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_DEFINE_FUN_REC (_menhir_stack, _startpos, _endpos) in
                let _menhir_s = MenhirState382 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    _menhir_run_209 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | _ ->
                    _eRR 382)
            | Tokens.DEFINE_FUNS_REC ->
                let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState326, _startpos) in
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_DEFINE_FUNS_REC (_menhir_stack, _startpos, _endpos) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                    let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
                    let _menhir_s = MenhirState386 in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.OPEN ->
                        _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                    | _ ->
                        _eRR 386)
                | _ ->
                    _eRR 385)
            | Tokens.DEFINE_FUN ->
                let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState326, _startpos) in
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_DEFINE_FUN (_menhir_stack, _startpos, _endpos) in
                let _menhir_s = MenhirState393 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    _menhir_run_209 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | _ ->
                    _eRR 393)
            | Tokens.DECLARE_SORT ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.NUM _v_56 ->
                        let _tok = _menhir_lexer _menhir_lexbuf in
                        (match (_tok : MenhirBasics.token) with
                        | Tokens.CLOSE ->
                            let _endpos_59 = _menhir_lexbuf.Lexing.lex_curr_p in
                            let _v =
                              let (_startpos__1_, s, n, _endpos__5_) = (_startpos, _v, _v_56, _endpos_59) in
                              _menhir_action_014 _endpos__5_ _startpos__1_ n s
                            in
                            _menhir_run_435 _menhir_stack _v
                        | _ ->
                            _eRR 398)
                    | _ ->
                        _eRR 397)
                | _ ->
                    _eRR 396)
            | Tokens.DECLARE_FUN ->
                let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState326, _startpos) in
                let _startpos_60 = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_DECLARE_FUN (_menhir_stack, _startpos_60, _endpos) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    let _startpos_61 = _menhir_lexbuf.Lexing.lex_start_p in
                    let _endpos_62 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos_61, _endpos_62) in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.OPEN ->
                        let _startpos_63 = _menhir_lexbuf.Lexing.lex_start_p in
                        let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos_63) in
                        let _tok = _menhir_lexer _menhir_lexbuf in
                        (match (_tok : MenhirBasics.token) with
                        | Tokens.SYMBOL _v_64 ->
                            _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v_64 MenhirState402
                        | Tokens.OPEN ->
                            _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState402
                        | Tokens.CLOSE ->
                            let _v_65 = _menhir_action_063 () in
                            _menhir_run_403 _menhir_stack _menhir_lexbuf _menhir_lexer _v_65 MenhirState402
                        | _ ->
                            _eRR 402)
                    | _ ->
                        _eRR 401)
                | _ ->
                    _eRR 400)
            | Tokens.DECLARE_DATATYPES ->
                let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState326, _startpos) in
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_DECLARE_DATATYPES (_menhir_stack, _startpos, _endpos) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                    let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
                    let _menhir_s = MenhirState408 in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.OPEN ->
                        _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                    | _ ->
                        _eRR 408)
                | _ ->
                    _eRR 407)
            | Tokens.DECLARE_DATATYPE ->
                let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState326, _startpos) in
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_DECLARE_DATATYPE (_menhir_stack, _startpos, _endpos) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                    let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos, _endpos) in
                    let _menhir_s = MenhirState416 in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.OPEN ->
                        _menhir_run_263 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                    | _ ->
                        _eRR 416)
                | _ ->
                    _eRR 415)
            | Tokens.DECLARE_CONST ->
                let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState326, _startpos) in
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_DECLARE_CONST (_menhir_stack, _startpos, _endpos) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                    let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos, _endpos) in
                    let _menhir_s = MenhirState420 in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.SYMBOL _v ->
                        _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                    | Tokens.OPEN ->
                        _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                    | _ ->
                        _eRR 420)
                | _ ->
                    _eRR 419)
            | Tokens.CHECK_SAT_ASSUMING ->
                let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState326, _startpos) in
                let _startpos_75 = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_CHECK_SAT_ASSUMING (_menhir_stack, _startpos_75, _endpos) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    let _startpos_76 = _menhir_lexbuf.Lexing.lex_start_p in
                    let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos_76) in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.SYMBOL _v ->
                        _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState424
                    | Tokens.OPEN ->
                        _menhir_run_304 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState424
                    | Tokens.CLOSE ->
                        let _v = _menhir_action_057 () in
                        _menhir_run_425 _menhir_stack _menhir_lexbuf _menhir_lexer _v
                    | _ ->
                        _eRR 424)
                | _ ->
                    _eRR 423)
            | Tokens.CHECK_SAT ->
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.CLOSE ->
                    let _endpos_78 = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _v =
                      let (_startpos__1_, _endpos__3_) = (_startpos, _endpos_78) in
                      _menhir_action_008 _endpos__3_ _startpos__1_
                    in
                    _menhir_run_435 _menhir_stack _v
                | _ ->
                    _eRR 428)
            | Tokens.ASSERT ->
                let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, MenhirState326, _startpos) in
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell0_ASSERT (_menhir_stack, _startpos, _endpos) in
                let _menhir_s = MenhirState430 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.STR _v ->
                    _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.OPEN ->
                    _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                | Tokens.NUM _v ->
                    _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.HEX _v ->
                    _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.DEC _v ->
                    _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.BIN _v ->
                    _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | _ ->
                    _eRR 430)
            | _ ->
                _eRR 327)
        | Tokens.EOF ->
            let _v = _menhir_action_051 () in
            _menhir_goto_input _menhir_stack _v
        | _ ->
            _eRR 326
    
    let _menhir_run_436 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_term =
      fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
        let _tok = _menhir_lexer _menhir_lexbuf in
        match (_tok : MenhirBasics.token) with
        | Tokens.SYMBOL _v ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _v =
              let s = _v in
              _menhir_action_045 s
            in
            _menhir_run_486 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v MenhirState436 _tok
        | Tokens.STR _v ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _v =
              let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
              _menhir_action_157 _endpos_s_ _startpos_s_ s
            in
            _menhir_run_484 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState436 _tok
        | Tokens.OPEN ->
            let _menhir_s = MenhirState436 in
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
            let _menhir_s = MenhirState439 in
            let _tok = _menhir_lexer _menhir_lexbuf in
            (match (_tok : MenhirBasics.token) with
            | Tokens.UNDERSCORE ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell1_UNDERSCORE (_menhir_stack, _menhir_s, _startpos, _endpos) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                    let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                    let _menhir_stack = MenhirCell0_SYMBOL (_menhir_stack, _v, _startpos, _endpos) in
                    let _menhir_s = MenhirState441 in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.SYMBOL _v ->
                        _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                    | Tokens.NUM _v ->
                        _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                    | Tokens.HEX _v ->
                        _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                    | _ ->
                        _eRR 441)
                | _ ->
                    _eRR 440)
            | Tokens.SYMBOL _v ->
                _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
            | Tokens.OPEN ->
                _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
            | Tokens.MATCH ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell1_MATCH (_menhir_stack, _menhir_s, _startpos, _endpos) in
                let _menhir_s = MenhirState444 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.STR _v ->
                    _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.OPEN ->
                    _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                | Tokens.NUM _v ->
                    _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.HEX _v ->
                    _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.DEC _v ->
                    _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.BIN _v ->
                    _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | _ ->
                    _eRR 444)
            | Tokens.LET ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell1_LET (_menhir_stack, _menhir_s, _startpos, _endpos) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                    let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
                    let _menhir_s = MenhirState451 in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.OPEN ->
                        _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                    | _ ->
                        _eRR 451)
                | _ ->
                    _eRR 450)
            | Tokens.FORALL ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell1_FORALL (_menhir_stack, _menhir_s, _startpos, _endpos) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                    let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
                    let _menhir_s = MenhirState457 in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.OPEN ->
                        _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                    | _ ->
                        _eRR 457)
                | _ ->
                    _eRR 456)
            | Tokens.EXISTS ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell1_EXISTS (_menhir_stack, _menhir_s, _startpos, _endpos) in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.OPEN ->
                    let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                    let _menhir_stack = MenhirCell0_OPEN (_menhir_stack, _startpos) in
                    let _menhir_s = MenhirState463 in
                    let _tok = _menhir_lexer _menhir_lexbuf in
                    (match (_tok : MenhirBasics.token) with
                    | Tokens.OPEN ->
                        _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                    | _ ->
                        _eRR 463)
                | _ ->
                    _eRR 462)
            | Tokens.ATTRIBUTE ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell1_ATTRIBUTE (_menhir_stack, _menhir_s, _startpos, _endpos) in
                let _menhir_s = MenhirState468 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.STR _v ->
                    _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.OPEN ->
                    _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                | Tokens.NUM _v ->
                    _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.HEX _v ->
                    _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.DEC _v ->
                    _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.BIN _v ->
                    _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | _ ->
                    _eRR 468)
            | Tokens.AS ->
                let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                let _menhir_stack = MenhirCell1_AS (_menhir_stack, _menhir_s, _startpos, _endpos) in
                let _menhir_s = MenhirState472 in
                let _tok = _menhir_lexer _menhir_lexbuf in
                (match (_tok : MenhirBasics.token) with
                | Tokens.SYMBOL _v ->
                    _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                | Tokens.OPEN ->
                    _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                | _ ->
                    _eRR 472)
            | _ ->
                _eRR 439)
        | Tokens.NUM _v ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _v =
              let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
              _menhir_action_153 _endpos_s_ _startpos_s_ s
            in
            _menhir_run_484 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState436 _tok
        | Tokens.HEX _v ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _v =
              let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
              _menhir_action_155 _endpos_s_ _startpos_s_ s
            in
            _menhir_run_484 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState436 _tok
        | Tokens.DEC _v ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _v =
              let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
              _menhir_action_154 _endpos_s_ _startpos_s_ s
            in
            _menhir_run_484 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState436 _tok
        | Tokens.BIN _v ->
            let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
            let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
            let _v =
              let (_endpos_s_, _startpos_s_, s) = (_endpos, _startpos, _v) in
              _menhir_action_156 _endpos_s_ _startpos_s_ s
            in
            _menhir_run_484 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState436 _tok
        | _ ->
            _eRR 436
    
  end
  
  let term =
    fun _menhir_lexer _menhir_lexbuf ->
      let _menhir_stack = () in
      let MenhirBox_term v = _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer in
      v
  
  let input =
    fun _menhir_lexer _menhir_lexbuf ->
      let _menhir_stack = () in
      let MenhirBox_input v = _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer in
      v
  
  let file =
    fun _menhir_lexer _menhir_lexbuf ->
      let _menhir_stack = () in
      let MenhirBox_file v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
      v
  
# 469 "src/languages/smtlib2/v2.6/script/parser.mly"
  

# 7493 "src/languages/smtlib2/v2.6/script/parser.ml"
  
end
